// { "framework": "Vue" }

/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;
/******/
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// identity function for calling harmony imports with the correct context
/******/ 	__webpack_require__.i = function(value) { return value; };
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 76);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ucapi = undefined;

var _logUtil = __webpack_require__(2);

var _weexRequire = __webpack_require__(3);

var _weexRequire2 = _interopRequireDefault(_weexRequire);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var jsBridge = (0, _weexRequire2.default)('uc-jsBridge');

function invoke(method, params, fail, success) {
  jsBridge.jsdkInvoke(method, JSON.stringify(params), function (result) {
    try {
      var jsonResult = JSON.parse(result);
      if (jsonResult.success) {
        success(jsonResult.data);
      } else {
        fail(jsonResult.data);
      }
    } catch (e) {
      (0, _logUtil.log)(e);
    } finally {}
  });
}

var apis = {
  exit: function exit() {
    invoke('lightapp.exit', '', function (data) {}, function (data) {});
  },
  addToNavigation: function addToNavigation(url, title, categoryId, fail, success) {
    invoke('lightapp.addToNavigation', { 'url': url, 'title': title, 'categoryId': categoryId }, fail, success);
  },
  openArticlePage: function openArticlePage(params, fail, success) {
    invoke('lightapp.openArticlePage', params, fail, success);
  },
  onGetArticleData: function onGetArticleData(params, fail, success) {
    invoke('lightapp.onGetArticleData', params, fail, success);
  },
  exitArticlePage: function exitArticlePage(params, fail, success) {
    invoke('lightapp.exitArticlePage', params, fail, success);
  },
  /*
   * 获取CategoryInfo
   * param : categoryId
   */
  getCachedCategoryInfo: function getCachedCategoryInfo(params, fail, success) {
    invoke('lightapp.getCachedCategoryInfo', params, fail, success);
  },
  /*
   * 更新CategoryInfo
   * params: category json string
   */
  updateCachedCategoryInfo: function updateCachedCategoryInfo(params, fail, success) {
    invoke('lightapp.updateCachedCategoryInfo', params, fail, success);
  },
  getCachedArticleList: function getCachedArticleList(params, fail, success) {
    invoke('lightapp.getCachedArticleList', params, fail, success);
  },
  updateCachedArticleList: function updateCachedArticleList(params, fail, success) {
    invoke('lightapp.updateCachedArticleList', params, fail, success);
  },
  gotoReport: function gotoReport(params, fail, success) {
    invoke('lightapp.gotoReport', params, fail, success);
  },
  gotoOrigin: function gotoOrigin(params, fail, success) {
    invoke('lightapp.gotoOrigin', params, fail, success);
  },
  stat: function stat(params, fail, success) {
    invoke('weex.stat', params, fail, success);
  }
};

var ucapi = {
  lightapp: apis
};

exports.ucapi = ucapi;

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.formatTime = formatTime;
// 讲时间转化为可显示的发布时间，如5分钟前等
function formatTime(time) {
  var result = '';
  var date = new Date();
  var currentTime = date.getTime();
  var timeDis = currentTime - time;

  // 计算出相差天数
  var days = Math.floor(timeDis / (24 * 3600 * 1000)
  // 计算出小时数
  );var leave1 = timeDis % (24 * 3600 * 1000); // 计算天数后剩余的毫秒数
  var hours = Math.floor(leave1 / (3600 * 1000)
  // 计算相差分钟数
  );var leave2 = leave1 % (3600 * 1000); // 计算小时数后剩余的毫秒数
  var minutes = Math.floor(leave2 / (60 * 1000));

  if (timeDis <= 0) {
    result = '0分钟前';
  } else if (days > 1) {
    var curDate = new Date(time);
    var curMonth = curDate.getMonth() + 1; // 获取当前月份(0-11,0代表1月)
    var curDay = curDate.getDate // 获取当前日(1-31)
    ();result = curMonth + '月' + curDay + '日';
  } else if (days > 0 && days <= 1) {
    result = '昨天';
  } else if (hours > 0 && hours <= 24) {
    result = hours + '小时前';
  } else {
    result = minutes + '分钟前';
  }
  return result;
}

function format(dateObj, formatString) {
  var patterns = {
    yyyy: dateObj.getFullYear(),
    'M{1,2}': dateObj.getMonth() + 1,
    'd{1,2}': dateObj.getDate(),
    'H{1,2}': dateObj.getHours(),
    'm{1,2}': dateObj.getMinutes(),
    's{1,2}': dateObj.getSeconds()
  };

  var ret = formatString;

  Object.keys(patterns).forEach(function (name) {
    var value = patterns[name];
    var execResult = new RegExp(name).exec(ret);

    if (execResult) {
      ret = ret.replace(execResult[0], '' + (execResult[0].length === 2 && String(value).length === 1 ? '0' : '') + value);
    }
  });

  return ret;
}

/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.enableLog = enableLog;
exports.log = log;
exports.logByTag = logByTag;
exports.toast = toast;
exports.toastOnDebug = toastOnDebug;

var _weexRequire = __webpack_require__(3);

var _weexRequire2 = _interopRequireDefault(_weexRequire);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ENABLE_LOG = true;

function enableLog(enable) {
  ENABLE_LOG = enable;
}

function log(message) {
  if (ENABLE_LOG) {
    console.log(message);
  }
}

function logByTag(tag, message) {
  if (ENABLE_LOG) {
    console.log(tag + ':' + message);
  }
}

function toast(text) {
  var modal = (0, _weexRequire2.default)('modal');
  modal.toast({
    message: text,
    duration: 1
  });
}

function toastOnDebug(text) {
  if (ENABLE_LOG) {
    var modal = (0, _weexRequire2.default)('modal');
    modal.toast({
      message: text,
      duration: 2
    });
  }
}

/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = weex.requireModule ? weex.requireModule : weex.require;

/***/ }),
/* 4 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.EventID = undefined;
exports.stat = stat;

var _jssdk = __webpack_require__(0);

var EventID = exports.EventID = {
  openChannelView: 'openChannelView',
  clickAddButton: 'clickAddButton',
  pullToRefresh: 'pullToRefresh',
  clikArticle: 'clikArticle',
  loadMoreArticles: 'loadMoreArticles',
  openArticleView: 'openArticleView',
  showArticleErrorTip: 'showArticleErrorTip',
  clickToReloadArtcle: 'clickToReloadArticle',
  jsRequest: 'jsRequest',
  jsRquestError: 'jsRequstError',
  fetchError: 'fetchError',
  fetchException: 'fetchException',
  fetchRequest: 'fetchRequest'
};

function stat(eventID, keyValue) {
  _jssdk.ucapi.lightapp.stat({
    event_category: 'lightapp',
    event_action: eventID,
    key_value: keyValue
  }, function (data) {}, function (data) {});
}

/***/ }),
/* 5 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
var globalState = {
  // 公参信息
  ucParamsObj: {},
  // 网络类型
  network: 'MOBILE',
  // 皮肤类型，使用语义化表述，d: 日间模式，n: 夜间模式，t: 透明模式
  themeType: 0
};

exports.globalState = globalState;

/***/ }),
/* 6 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.fetchCategoryInfo = fetchCategoryInfo;
exports.fetchArticleList = fetchArticleList;
exports.fetchArticle = fetchArticle;
exports.fetchNextUrl = fetchNextUrl;

var _weexRequire = __webpack_require__(3);

var _weexRequire2 = _interopRequireDefault(_weexRequire);

var _logUtil = __webpack_require__(2);

var _statUtil = __webpack_require__(4);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var stream = (0, _weexRequire2.default)('stream');
var baseURL = 'https://api.qingmang.me/v2/';


function fetch(path, data, timeout) {
  var querystring = Object.keys(data).map(function (key) {
    return key + '=' + encodeURIComponent(data[key]);
  }).join('&');
  (0, _logUtil.logByTag)('fetch', baseURL + path + '?' + querystring);
  (0, _statUtil.stat)(_statUtil.EventID.fetchRequest, {
    fetch_url: baseURL + path + '?' + querystring
  });
  return new Promise(function (resolve, reject) {
    stream.fetch({
      method: 'GET',
      timeout: timeout,
      url: baseURL + path + '?' + querystring
    }, function (response) {
      try {
        if (response.status === 200) {
          var resultData = JSON.parse(response.data);
          resolve({
            resultCode: 'success',
            resultMsg: resultData
          });
        } else {
          (0, _logUtil.logByTag)('fetch', response);
          (0, _statUtil.stat)(_statUtil.EventID.fetchError, {
            fetch_url: baseURL + path + '?' + querystring,
            fetch_response: String(response.status)
          });
          reject({
            resultCode: 'error',
            resultMsg: response
          });
        }
      } catch (e) {
        (0, _logUtil.logByTag)('fetch', e);
        (0, _logUtil.logByTag)('fetch', response);
        (0, _statUtil.stat)(_statUtil.EventID.fetchException, {
          fetch_url: baseURL + path + '?' + querystring,
          fetch_exception: String(e)
        });
        reject({
          resultCode: 'error',
          resultMsg: 'json parse exception\n' + response
        });
      } finally {}
    }, function () {});
  });
}

function fetchUrl(nextUrl, timeout) {
  (0, _logUtil.logByTag)('fetch', nextUrl);
  (0, _statUtil.stat)(_statUtil.EventID.fetchRequest, {
    fetch_url: nextUrl
  });
  return new Promise(function (resolve, reject) {
    stream.fetch({
      method: 'GET',
      timeout: timeout,
      url: nextUrl
    }, function (response) {
      try {
        if (response.status === 200) {
          var resultData = JSON.parse(response.data);
          resolve({
            resultCode: 'success',
            resultMsg: resultData
          });
        } else {
          (0, _statUtil.stat)(_statUtil.EventID.fetchError, {
            fetch_url: nextUrl,
            fetch_response: response.status
          });
          (0, _logUtil.logByTag)('fetch', response);
          reject({
            resultCode: 'error',
            resultMsg: response
          });
        }
      } catch (e) {
        (0, _statUtil.stat)(_statUtil.EventID.fetchException, {
          fetch_url: nextUrl,
          fetch_exception: e
        });
        (0, _logUtil.logByTag)('fetch', e);
        (0, _logUtil.logByTag)('fetch', response);
        reject({
          resultCode: 'error',
          resultMsg: 'json parse exception\n' + response
        });
      } finally {}
    }, function () {});
  });
}

// 获取指定CategoryID的详细信息
function fetchCategoryInfo(userToken, categoryId, valueCallback, timeout) {
  var datas = {
    token: userToken,
    category_id: categoryId
  };
  fetch('category.get', datas, timeout).then(valueCallback, valueCallback);
}

// 获取指定CategoryID对应的文章列表
function fetchArticleList(userToken, categoryId, valueCallback, timeout) {
  var datas = {
    token: userToken,
    category_id: categoryId
  };
  fetch('article.list', datas, timeout).then(valueCallback, valueCallback);
}

// 获取指定articleID的文章内容
function fetchArticle(userToken, articleId, valueCallback, timeout) {
  var datas = {
    token: userToken,
    id: articleId,
    format: 'raml'
  };
  fetch('article.get', datas, timeout).then(valueCallback, valueCallback);
}

function fetchNextUrl(nextUrl, valueCallback, timeout) {
  fetchUrl(nextUrl, timeout).then(valueCallback, valueCallback);
}

/***/ }),
/* 7 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isChannelPath = isChannelPath;
exports.isArticlePath = isArticlePath;

var _vueRouter = __webpack_require__(12);

var _vueRouter2 = _interopRequireDefault(_vueRouter);

var _ArticleView = __webpack_require__(27);

var _ArticleView2 = _interopRequireDefault(_ArticleView);

var _ChannelView = __webpack_require__(28);

var _ChannelView2 = _interopRequireDefault(_ChannelView);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

Vue.use(_vueRouter2.default

// view factory
); // import Vue from 'vue'
function createSimpleView() {
  return {
    name: '',
    render: function render(createElement) {
      return createElement(_ArticleView2.default);
    }
  };
}

function isChannelPath(path) {
  return path === '/channel';
}

function isArticlePath(path) {
  return path === '/article';
}

exports.default = new _vueRouter2.default({
  routes: [{ name: 'channel', path: '/channel', component: _ChannelView2.default }, { name: 'article', path: '/article', component: _ArticleView2.default }, { path: '/', redirect: 'channel' }]
});

/***/ }),
/* 8 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.cacheCategoryInfo = cacheCategoryInfo;
exports.getCachedCategoryInfo = getCachedCategoryInfo;
exports.cacheArticleList = cacheArticleList;
exports.getCachedArticleList = getCachedArticleList;

var _jssdk = __webpack_require__(0);

var _logUtil = __webpack_require__(2);

function cacheCategoryInfo(categoryInfo) {
  var categoryId = categoryInfo.categoryId;
  setTimeout(function () {
    _jssdk.ucapi.lightapp.updateCachedCategoryInfo({
      'categoryId': categoryId,
      'categoryInfo': categoryInfo
    }, function (data) {
      (0, _logUtil.logByTag)('cache', data);
    }, function (data) {
      (0, _logUtil.logByTag)('cache', data);
    });
  }, 1000);
}

function getCachedCategoryInfo(categoryId, fail, success) {
  _jssdk.ucapi.lightapp.getCachedCategoryInfo({ 'categoryId': categoryId }, fail, success);
}

function cacheArticleList(categoryId, articleList) {
  setTimeout(function () {
    _jssdk.ucapi.lightapp.updateCachedArticleList({
      'categoryId': categoryId,
      'articleList': articleList
    }, function (data) {
      (0, _logUtil.logByTag)('cache', data);
    }, function (data) {
      (0, _logUtil.logByTag)('cache', data);
    });
  }, 1000);
}

function getCachedArticleList(categoryId, fail, success) {
  _jssdk.ucapi.lightapp.getCachedArticleList({ 'categoryId': categoryId }, fail, success);
}

/***/ }),
/* 9 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _logUtil = __webpack_require__(2);

var _app = __webpack_require__(5);

exports.default = {
  methods: {
    toastOnDebug: function toastOnDebug(text) {
      (0, _logUtil.toastOnDebug)(text);
    },
    toast: function toast(text) {
      (0, _logUtil.toast)(text);
    },
    log: function log(message) {
      (0, _logUtil.log)(message);
    },
    logByTag: function logByTag(tag, message) {
      (0, _logUtil.logByTag)(tag, message);
    },
    ucConfig: function ucConfig() {
      return this.$getConfig().uc;
    },
    themeClass: function themeClass(value) {
      if (this.themeType != 1) return [value];
      return [value, value + '_' + 'nig'];
    },
    isNightTheme: function isNightTheme() {
      return this.themeType == 1;
    },
    dpToPx: function dpToPx(value) {
      return this.$getConfig().uc.env.pixelRatio * value;
    },
    pxToDp: function pxToDp(value) {
      return value / this.$getConfig().uc.env.pixelRatio;
    },
    isAndroidOs: function isAndroidOs() {
      return this.$getConfig().uc.os === "android";
    },
    imgSrcExtend: function imgSrcExtend(value, isSmall) {
      // 判断是否是轻芒的图片来源
      if (value.indexOf("qingmang.") > 0) {
        var params = isSmall ? this.$getConfig().imageUrlParamsSmall : this.$getConfig().imageUrlParamsBig;
        if (!params) {
          params = "";
        }
        return value + params;
      }
      return value;
    },
    getScreenHeightPx: function getScreenHeightPx() {
      return this.$getConfig().uc.env.windowHeight * this.$getConfig().uc.env.pixelRatio;
    },
    getScreenWidthPx: function getScreenWidthPx() {
      return this.$getConfig().uc.env.windowWidth * this.$getConfig().uc.env.pixelRatio;
    },
    mixTwoColors: function mixTwoColors(color1, color2, amount) {
      var ALPHA_CHANNEL = 24;
      var RED_CHANNEL = 16;
      var GREEN_CHANNEL = 8;
      var BLUE_CHANNEL = 0;

      var inverseAmount = 1.0 - amount;

      var a = (color1 >> ALPHA_CHANNEL & 0xff) * amount + (color2 >> ALPHA_CHANNEL & 0xff) * inverseAmount & 0xff;
      var r = (color1 >> RED_CHANNEL & 0xff) * amount + (color2 >> RED_CHANNEL & 0xff) * inverseAmount & 0xff;
      var g = (color1 >> GREEN_CHANNEL & 0xff) * amount + (color2 >> GREEN_CHANNEL & 0xff) * inverseAmount & 0xff;
      var b = (color1 & 0xff) * amount + (color2 & 0xff) * inverseAmount & 0xff;

      return a << ALPHA_CHANNEL | r << RED_CHANNEL | g << GREEN_CHANNEL | b << BLUE_CHANNEL;
    }
  }
};

/***/ }),
/* 10 */
/***/ (function(module, exports, __webpack_require__) {

var __vue_exports__, __vue_options__
var __vue_styles__ = []

/* styles */
__vue_styles__.push(__webpack_require__(50)
)

/* script */
__vue_exports__ = __webpack_require__(29)

/* template */
var __vue_template__ = __webpack_require__(65)
__vue_options__ = __vue_exports__ = __vue_exports__ || {}
if (
  typeof __vue_exports__.default === "object" ||
  typeof __vue_exports__.default === "function"
) {
if (Object.keys(__vue_exports__).some(function (key) { return key !== "default" && key !== "__esModule" })) {console.error("named exports are not supported in *.vue files.")}
__vue_options__ = __vue_exports__ = __vue_exports__.default
}
if (typeof __vue_options__ === "function") {
  __vue_options__ = __vue_options__.options
}
__vue_options__.__file = "/AliGitLab/qk-lightApp/src/App.vue"
__vue_options__.render = __vue_template__.render
__vue_options__.staticRenderFns = __vue_template__.staticRenderFns
__vue_options__._scopeId = "data-v-381e6d24"
__vue_options__.style = __vue_options__.style || {}
__vue_styles__.forEach(function (module) {
  for (var name in module) {
    __vue_options__.style[name] = module[name]
  }
})
if (typeof __register_static_styles__ === "function") {
  __register_static_styles__(__vue_options__._scopeId, __vue_styles__)
}

module.exports = __vue_exports__


/***/ }),
/* 11 */
/***/ (function(module, exports) {

// shim for using process in browser
var process = module.exports = {};

// cached from whatever global is present so that test runners that stub it
// don't break things.  But we need to wrap it in a try catch in case it is
// wrapped in strict mode code which doesn't define any globals.  It's inside a
// function because try/catches deoptimize in certain engines.

var cachedSetTimeout;
var cachedClearTimeout;

function defaultSetTimout() {
    throw new Error('setTimeout has not been defined');
}
function defaultClearTimeout () {
    throw new Error('clearTimeout has not been defined');
}
(function () {
    try {
        if (typeof setTimeout === 'function') {
            cachedSetTimeout = setTimeout;
        } else {
            cachedSetTimeout = defaultSetTimout;
        }
    } catch (e) {
        cachedSetTimeout = defaultSetTimout;
    }
    try {
        if (typeof clearTimeout === 'function') {
            cachedClearTimeout = clearTimeout;
        } else {
            cachedClearTimeout = defaultClearTimeout;
        }
    } catch (e) {
        cachedClearTimeout = defaultClearTimeout;
    }
} ())
function runTimeout(fun) {
    if (cachedSetTimeout === setTimeout) {
        //normal enviroments in sane situations
        return setTimeout(fun, 0);
    }
    // if setTimeout wasn't available but was latter defined
    if ((cachedSetTimeout === defaultSetTimout || !cachedSetTimeout) && setTimeout) {
        cachedSetTimeout = setTimeout;
        return setTimeout(fun, 0);
    }
    try {
        // when when somebody has screwed with setTimeout but no I.E. maddness
        return cachedSetTimeout(fun, 0);
    } catch(e){
        try {
            // When we are in I.E. but the script has been evaled so I.E. doesn't trust the global object when called normally
            return cachedSetTimeout.call(null, fun, 0);
        } catch(e){
            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error
            return cachedSetTimeout.call(this, fun, 0);
        }
    }


}
function runClearTimeout(marker) {
    if (cachedClearTimeout === clearTimeout) {
        //normal enviroments in sane situations
        return clearTimeout(marker);
    }
    // if clearTimeout wasn't available but was latter defined
    if ((cachedClearTimeout === defaultClearTimeout || !cachedClearTimeout) && clearTimeout) {
        cachedClearTimeout = clearTimeout;
        return clearTimeout(marker);
    }
    try {
        // when when somebody has screwed with setTimeout but no I.E. maddness
        return cachedClearTimeout(marker);
    } catch (e){
        try {
            // When we are in I.E. but the script has been evaled so I.E. doesn't  trust the global object when called normally
            return cachedClearTimeout.call(null, marker);
        } catch (e){
            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error.
            // Some versions of I.E. have different rules for clearTimeout vs setTimeout
            return cachedClearTimeout.call(this, marker);
        }
    }



}
var queue = [];
var draining = false;
var currentQueue;
var queueIndex = -1;

function cleanUpNextTick() {
    if (!draining || !currentQueue) {
        return;
    }
    draining = false;
    if (currentQueue.length) {
        queue = currentQueue.concat(queue);
    } else {
        queueIndex = -1;
    }
    if (queue.length) {
        drainQueue();
    }
}

function drainQueue() {
    if (draining) {
        return;
    }
    var timeout = runTimeout(cleanUpNextTick);
    draining = true;

    var len = queue.length;
    while(len) {
        currentQueue = queue;
        queue = [];
        while (++queueIndex < len) {
            if (currentQueue) {
                currentQueue[queueIndex].run();
            }
        }
        queueIndex = -1;
        len = queue.length;
    }
    currentQueue = null;
    draining = false;
    runClearTimeout(timeout);
}

process.nextTick = function (fun) {
    var args = new Array(arguments.length - 1);
    if (arguments.length > 1) {
        for (var i = 1; i < arguments.length; i++) {
            args[i - 1] = arguments[i];
        }
    }
    queue.push(new Item(fun, args));
    if (queue.length === 1 && !draining) {
        runTimeout(drainQueue);
    }
};

// v8 likes predictible objects
function Item(fun, array) {
    this.fun = fun;
    this.array = array;
}
Item.prototype.run = function () {
    this.fun.apply(null, this.array);
};
process.title = 'browser';
process.browser = true;
process.env = {};
process.argv = [];
process.version = ''; // empty string to avoid regexp issues
process.versions = {};

function noop() {}

process.on = noop;
process.addListener = noop;
process.once = noop;
process.off = noop;
process.removeListener = noop;
process.removeAllListeners = noop;
process.emit = noop;
process.prependListener = noop;
process.prependOnceListener = noop;

process.listeners = function (name) { return [] }

process.binding = function (name) {
    throw new Error('process.binding is not supported');
};

process.cwd = function () { return '/' };
process.chdir = function (dir) {
    throw new Error('process.chdir is not supported');
};
process.umask = function() { return 0; };


/***/ }),
/* 12 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(process) {Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/**
  * vue-router v2.5.3
  * (c) 2017 Evan You
  * @license MIT
  */
/*  */

function assert (condition, message) {
  if (!condition) {
    throw new Error(("[vue-router] " + message))
  }
}

function warn (condition, message) {
  if (process.env.NODE_ENV !== 'production' && !condition) {
    typeof console !== 'undefined' && console.warn(("[vue-router] " + message));
  }
}

var View = {
  name: 'router-view',
  functional: true,
  props: {
    name: {
      type: String,
      default: 'default'
    }
  },
  render: function render (_, ref) {
    var props = ref.props;
    var children = ref.children;
    var parent = ref.parent;
    var data = ref.data;

    data.routerView = true;

    // directly use parent context's createElement() function
    // so that components rendered by router-view can resolve named slots
    var h = parent.$createElement;
    var name = props.name;
    var route = parent.$route;
    var cache = parent._routerViewCache || (parent._routerViewCache = {});

    // determine current view depth, also check to see if the tree
    // has been toggled inactive but kept-alive.
    var depth = 0;
    var inactive = false;
    while (parent) {
      if (parent.$vnode && parent.$vnode.data.routerView) {
        depth++;
      }
      if (parent._inactive) {
        inactive = true;
      }
      parent = parent.$parent;
    }
    data.routerViewDepth = depth;

    // render previous view if the tree is inactive and kept-alive
    if (inactive) {
      return h(cache[name], data, children)
    }

    var matched = route.matched[depth];
    // render empty node if no matched route
    if (!matched) {
      cache[name] = null;
      return h()
    }

    var component = cache[name] = matched.components[name];

    // attach instance registration hook
    // this will be called in the instance's injected lifecycle hooks
    data.registerRouteInstance = function (vm, val) {
      // val could be undefined for unregistration
      var current = matched.instances[name];
      if (
        (val && current !== vm) ||
        (!val && current === vm)
      ) {
        matched.instances[name] = val;
      }
    }

    // also regiseter instance in prepatch hook
    // in case the same component instance is reused across different routes
    ;(data.hook || (data.hook = {})).prepatch = function (_, vnode) {
      matched.instances[name] = vnode.componentInstance;
    };

    // resolve props
    data.props = resolveProps(route, matched.props && matched.props[name]);

    return h(component, data, children)
  }
};

function resolveProps (route, config) {
  switch (typeof config) {
    case 'undefined':
      return
    case 'object':
      return config
    case 'function':
      return config(route)
    case 'boolean':
      return config ? route.params : undefined
    default:
      if (process.env.NODE_ENV !== 'production') {
        warn(
          false,
          "props in \"" + (route.path) + "\" is a " + (typeof config) + ", " +
          "expecting an object, function or boolean."
        );
      }
  }
}

/*  */

var encodeReserveRE = /[!'()*]/g;
var encodeReserveReplacer = function (c) { return '%' + c.charCodeAt(0).toString(16); };
var commaRE = /%2C/g;

// fixed encodeURIComponent which is more conformant to RFC3986:
// - escapes [!'()*]
// - preserve commas
var encode = function (str) { return encodeURIComponent(str)
  .replace(encodeReserveRE, encodeReserveReplacer)
  .replace(commaRE, ','); };

var decode = decodeURIComponent;

function resolveQuery (
  query,
  extraQuery,
  _parseQuery
) {
  if ( extraQuery === void 0 ) extraQuery = {};

  var parse = _parseQuery || parseQuery;
  var parsedQuery;
  try {
    parsedQuery = parse(query || '');
  } catch (e) {
    process.env.NODE_ENV !== 'production' && warn(false, e.message);
    parsedQuery = {};
  }
  for (var key in extraQuery) {
    var val = extraQuery[key];
    parsedQuery[key] = Array.isArray(val) ? val.slice() : val;
  }
  return parsedQuery
}

function parseQuery (query) {
  var res = {};

  query = query.trim().replace(/^(\?|#|&)/, '');

  if (!query) {
    return res
  }

  query.split('&').forEach(function (param) {
    var parts = param.replace(/\+/g, ' ').split('=');
    var key = decode(parts.shift());
    var val = parts.length > 0
      ? decode(parts.join('='))
      : null;

    if (res[key] === undefined) {
      res[key] = val;
    } else if (Array.isArray(res[key])) {
      res[key].push(val);
    } else {
      res[key] = [res[key], val];
    }
  });

  return res
}

function stringifyQuery (obj) {
  var res = obj ? Object.keys(obj).map(function (key) {
    var val = obj[key];

    if (val === undefined) {
      return ''
    }

    if (val === null) {
      return encode(key)
    }

    if (Array.isArray(val)) {
      var result = [];
      val.slice().forEach(function (val2) {
        if (val2 === undefined) {
          return
        }
        if (val2 === null) {
          result.push(encode(key));
        } else {
          result.push(encode(key) + '=' + encode(val2));
        }
      });
      return result.join('&')
    }

    return encode(key) + '=' + encode(val)
  }).filter(function (x) { return x.length > 0; }).join('&') : null;
  return res ? ("?" + res) : ''
}

/*  */


var trailingSlashRE = /\/?$/;

function createRoute (
  record,
  location,
  redirectedFrom,
  router
) {
  var stringifyQuery$$1 = router && router.options.stringifyQuery;
  var route = {
    name: location.name || (record && record.name),
    meta: (record && record.meta) || {},
    path: location.path || '/',
    hash: location.hash || '',
    query: location.query || {},
    params: location.params || {},
    fullPath: getFullPath(location, stringifyQuery$$1),
    matched: record ? formatMatch(record) : []
  };
  if (redirectedFrom) {
    route.redirectedFrom = getFullPath(redirectedFrom, stringifyQuery$$1);
  }
  return Object.freeze(route)
}

// the starting route that represents the initial state
var START = createRoute(null, {
  path: '/'
});

function formatMatch (record) {
  var res = [];
  while (record) {
    res.unshift(record);
    record = record.parent;
  }
  return res
}

function getFullPath (
  ref,
  _stringifyQuery
) {
  var path = ref.path;
  var query = ref.query; if ( query === void 0 ) query = {};
  var hash = ref.hash; if ( hash === void 0 ) hash = '';

  var stringify = _stringifyQuery || stringifyQuery;
  return (path || '/') + stringify(query) + hash
}

function isSameRoute (a, b) {
  if (b === START) {
    return a === b
  } else if (!b) {
    return false
  } else if (a.path && b.path) {
    return (
      a.path.replace(trailingSlashRE, '') === b.path.replace(trailingSlashRE, '') &&
      a.hash === b.hash &&
      isObjectEqual(a.query, b.query)
    )
  } else if (a.name && b.name) {
    return (
      a.name === b.name &&
      a.hash === b.hash &&
      isObjectEqual(a.query, b.query) &&
      isObjectEqual(a.params, b.params)
    )
  } else {
    return false
  }
}

function isObjectEqual (a, b) {
  if ( a === void 0 ) a = {};
  if ( b === void 0 ) b = {};

  var aKeys = Object.keys(a);
  var bKeys = Object.keys(b);
  if (aKeys.length !== bKeys.length) {
    return false
  }
  return aKeys.every(function (key) { return String(a[key]) === String(b[key]); })
}

function isIncludedRoute (current, target) {
  return (
    current.path.replace(trailingSlashRE, '/').indexOf(
      target.path.replace(trailingSlashRE, '/')
    ) === 0 &&
    (!target.hash || current.hash === target.hash) &&
    queryIncludes(current.query, target.query)
  )
}

function queryIncludes (current, target) {
  for (var key in target) {
    if (!(key in current)) {
      return false
    }
  }
  return true
}

/*  */

// work around weird flow bug
var toTypes = [String, Object];
var eventTypes = [String, Array];

var Link = {
  name: 'router-link',
  props: {
    to: {
      type: toTypes,
      required: true
    },
    tag: {
      type: String,
      default: 'a'
    },
    exact: Boolean,
    append: Boolean,
    replace: Boolean,
    activeClass: String,
    exactActiveClass: String,
    event: {
      type: eventTypes,
      default: 'click'
    }
  },
  render: function render (h) {
    var this$1 = this;

    var router = this.$router;
    var current = this.$route;
    var ref = router.resolve(this.to, current, this.append);
    var location = ref.location;
    var route = ref.route;
    var href = ref.href;

    var classes = {};
    var globalActiveClass = router.options.linkActiveClass;
    var globalExactActiveClass = router.options.linkExactActiveClass;
    // Support global empty active class
    var activeClassFallback = globalActiveClass == null
            ? 'router-link-active'
            : globalActiveClass;
    var exactActiveClassFallback = globalExactActiveClass == null
            ? 'router-link-exact-active'
            : globalExactActiveClass;
    var activeClass = this.activeClass == null
            ? activeClassFallback
            : this.activeClass;
    var exactActiveClass = this.exactActiveClass == null
            ? exactActiveClassFallback
            : this.exactActiveClass;
    var compareTarget = location.path
      ? createRoute(null, location, null, router)
      : route;

    classes[exactActiveClass] = isSameRoute(current, compareTarget);
    classes[activeClass] = this.exact
      ? classes[exactActiveClass]
      : isIncludedRoute(current, compareTarget);

    var handler = function (e) {
      if (guardEvent(e)) {
        if (this$1.replace) {
          router.replace(location);
        } else {
          router.push(location);
        }
      }
    };

    var on = { click: guardEvent };
    if (Array.isArray(this.event)) {
      this.event.forEach(function (e) { on[e] = handler; });
    } else {
      on[this.event] = handler;
    }

    var data = {
      class: classes
    };

    if (this.tag === 'a') {
      data.on = on;
      data.attrs = { href: href };
    } else {
      // find the first <a> child and apply listener and href
      var a = findAnchor(this.$slots.default);
      if (a) {
        // in case the <a> is a static node
        a.isStatic = false;
        var extend = _Vue.util.extend;
        var aData = a.data = extend({}, a.data);
        aData.on = on;
        var aAttrs = a.data.attrs = extend({}, a.data.attrs);
        aAttrs.href = href;
      } else {
        // doesn't have <a> child, apply listener to self
        data.on = on;
      }
    }

    return h(this.tag, data, this.$slots.default)
  }
};

function guardEvent (e) {
  // don't redirect with control keys
  if (e.metaKey || e.ctrlKey || e.shiftKey) { return }
  // don't redirect when preventDefault called
  if (e.defaultPrevented) { return }
  // don't redirect on right click
  if (e.button !== undefined && e.button !== 0) { return }
  // don't redirect if `target="_blank"`
  if (e.currentTarget && e.currentTarget.getAttribute) {
    var target = e.currentTarget.getAttribute('target');
    if (/\b_blank\b/i.test(target)) { return }
  }
  // this may be a Weex event which doesn't have this method
  if (e.preventDefault) {
    e.preventDefault();
  }
  return true
}

function findAnchor (children) {
  if (children) {
    var child;
    for (var i = 0; i < children.length; i++) {
      child = children[i];
      if (child.tag === 'a') {
        return child
      }
      if (child.children && (child = findAnchor(child.children))) {
        return child
      }
    }
  }
}

var _Vue;

function install (Vue) {
  if (install.installed) { return }
  install.installed = true;

  _Vue = Vue;

  Object.defineProperty(Vue.prototype, '$router', {
    get: function get () { return this.$root._router }
  });

  Object.defineProperty(Vue.prototype, '$route', {
    get: function get () { return this.$root._route }
  });

  var isDef = function (v) { return v !== undefined; };

  var registerInstance = function (vm, callVal) {
    var i = vm.$options._parentVnode;
    if (isDef(i) && isDef(i = i.data) && isDef(i = i.registerRouteInstance)) {
      i(vm, callVal);
    }
  };

  Vue.mixin({
    beforeCreate: function beforeCreate () {
      if (isDef(this.$options.router)) {
        this._router = this.$options.router;
        this._router.init(this);
        Vue.util.defineReactive(this, '_route', this._router.history.current);
      }
      registerInstance(this, this);
    },
    destroyed: function destroyed () {
      registerInstance(this);
    }
  });

  Vue.component('router-view', View);
  Vue.component('router-link', Link);

  var strats = Vue.config.optionMergeStrategies;
  // use the same hook merging strategy for route hooks
  strats.beforeRouteEnter = strats.beforeRouteLeave = strats.created;
}

/*  */

var inBrowser = typeof window !== 'undefined';

/*  */

function resolvePath (
  relative,
  base,
  append
) {
  var firstChar = relative.charAt(0);
  if (firstChar === '/') {
    return relative
  }

  if (firstChar === '?' || firstChar === '#') {
    return base + relative
  }

  var stack = base.split('/');

  // remove trailing segment if:
  // - not appending
  // - appending to trailing slash (last segment is empty)
  if (!append || !stack[stack.length - 1]) {
    stack.pop();
  }

  // resolve relative path
  var segments = relative.replace(/^\//, '').split('/');
  for (var i = 0; i < segments.length; i++) {
    var segment = segments[i];
    if (segment === '..') {
      stack.pop();
    } else if (segment !== '.') {
      stack.push(segment);
    }
  }

  // ensure leading slash
  if (stack[0] !== '') {
    stack.unshift('');
  }

  return stack.join('/')
}

function parsePath (path) {
  var hash = '';
  var query = '';

  var hashIndex = path.indexOf('#');
  if (hashIndex >= 0) {
    hash = path.slice(hashIndex);
    path = path.slice(0, hashIndex);
  }

  var queryIndex = path.indexOf('?');
  if (queryIndex >= 0) {
    query = path.slice(queryIndex + 1);
    path = path.slice(0, queryIndex);
  }

  return {
    path: path,
    query: query,
    hash: hash
  }
}

function cleanPath (path) {
  return path.replace(/\/\//g, '/')
}

var index$1 = Array.isArray || function (arr) {
  return Object.prototype.toString.call(arr) == '[object Array]';
};

/**
 * Expose `pathToRegexp`.
 */
var index = pathToRegexp;
var parse_1 = parse;
var compile_1 = compile;
var tokensToFunction_1 = tokensToFunction;
var tokensToRegExp_1 = tokensToRegExp;

/**
 * The main path matching regexp utility.
 *
 * @type {RegExp}
 */
var PATH_REGEXP = new RegExp([
  // Match escaped characters that would otherwise appear in future matches.
  // This allows the user to escape special characters that won't transform.
  '(\\\\.)',
  // Match Express-style parameters and un-named parameters with a prefix
  // and optional suffixes. Matches appear as:
  //
  // "/:test(\\d+)?" => ["/", "test", "\d+", undefined, "?", undefined]
  // "/route(\\d+)"  => [undefined, undefined, undefined, "\d+", undefined, undefined]
  // "/*"            => ["/", undefined, undefined, undefined, undefined, "*"]
  '([\\/.])?(?:(?:\\:(\\w+)(?:\\(((?:\\\\.|[^\\\\()])+)\\))?|\\(((?:\\\\.|[^\\\\()])+)\\))([+*?])?|(\\*))'
].join('|'), 'g');

/**
 * Parse a string for the raw tokens.
 *
 * @param  {string}  str
 * @param  {Object=} options
 * @return {!Array}
 */
function parse (str, options) {
  var tokens = [];
  var key = 0;
  var index = 0;
  var path = '';
  var defaultDelimiter = options && options.delimiter || '/';
  var res;

  while ((res = PATH_REGEXP.exec(str)) != null) {
    var m = res[0];
    var escaped = res[1];
    var offset = res.index;
    path += str.slice(index, offset);
    index = offset + m.length;

    // Ignore already escaped sequences.
    if (escaped) {
      path += escaped[1];
      continue
    }

    var next = str[index];
    var prefix = res[2];
    var name = res[3];
    var capture = res[4];
    var group = res[5];
    var modifier = res[6];
    var asterisk = res[7];

    // Push the current path onto the tokens.
    if (path) {
      tokens.push(path);
      path = '';
    }

    var partial = prefix != null && next != null && next !== prefix;
    var repeat = modifier === '+' || modifier === '*';
    var optional = modifier === '?' || modifier === '*';
    var delimiter = res[2] || defaultDelimiter;
    var pattern = capture || group;

    tokens.push({
      name: name || key++,
      prefix: prefix || '',
      delimiter: delimiter,
      optional: optional,
      repeat: repeat,
      partial: partial,
      asterisk: !!asterisk,
      pattern: pattern ? escapeGroup(pattern) : (asterisk ? '.*' : '[^' + escapeString(delimiter) + ']+?')
    });
  }

  // Match any characters still remaining.
  if (index < str.length) {
    path += str.substr(index);
  }

  // If the path exists, push it onto the end.
  if (path) {
    tokens.push(path);
  }

  return tokens
}

/**
 * Compile a string to a template function for the path.
 *
 * @param  {string}             str
 * @param  {Object=}            options
 * @return {!function(Object=, Object=)}
 */
function compile (str, options) {
  return tokensToFunction(parse(str, options))
}

/**
 * Prettier encoding of URI path segments.
 *
 * @param  {string}
 * @return {string}
 */
function encodeURIComponentPretty (str) {
  return encodeURI(str).replace(/[\/?#]/g, function (c) {
    return '%' + c.charCodeAt(0).toString(16).toUpperCase()
  })
}

/**
 * Encode the asterisk parameter. Similar to `pretty`, but allows slashes.
 *
 * @param  {string}
 * @return {string}
 */
function encodeAsterisk (str) {
  return encodeURI(str).replace(/[?#]/g, function (c) {
    return '%' + c.charCodeAt(0).toString(16).toUpperCase()
  })
}

/**
 * Expose a method for transforming tokens into the path function.
 */
function tokensToFunction (tokens) {
  // Compile all the tokens into regexps.
  var matches = new Array(tokens.length);

  // Compile all the patterns before compilation.
  for (var i = 0; i < tokens.length; i++) {
    if (typeof tokens[i] === 'object') {
      matches[i] = new RegExp('^(?:' + tokens[i].pattern + ')$');
    }
  }

  return function (obj, opts) {
    var path = '';
    var data = obj || {};
    var options = opts || {};
    var encode = options.pretty ? encodeURIComponentPretty : encodeURIComponent;

    for (var i = 0; i < tokens.length; i++) {
      var token = tokens[i];

      if (typeof token === 'string') {
        path += token;

        continue
      }

      var value = data[token.name];
      var segment;

      if (value == null) {
        if (token.optional) {
          // Prepend partial segment prefixes.
          if (token.partial) {
            path += token.prefix;
          }

          continue
        } else {
          throw new TypeError('Expected "' + token.name + '" to be defined')
        }
      }

      if (index$1(value)) {
        if (!token.repeat) {
          throw new TypeError('Expected "' + token.name + '" to not repeat, but received `' + JSON.stringify(value) + '`')
        }

        if (value.length === 0) {
          if (token.optional) {
            continue
          } else {
            throw new TypeError('Expected "' + token.name + '" to not be empty')
          }
        }

        for (var j = 0; j < value.length; j++) {
          segment = encode(value[j]);

          if (!matches[i].test(segment)) {
            throw new TypeError('Expected all "' + token.name + '" to match "' + token.pattern + '", but received `' + JSON.stringify(segment) + '`')
          }

          path += (j === 0 ? token.prefix : token.delimiter) + segment;
        }

        continue
      }

      segment = token.asterisk ? encodeAsterisk(value) : encode(value);

      if (!matches[i].test(segment)) {
        throw new TypeError('Expected "' + token.name + '" to match "' + token.pattern + '", but received "' + segment + '"')
      }

      path += token.prefix + segment;
    }

    return path
  }
}

/**
 * Escape a regular expression string.
 *
 * @param  {string} str
 * @return {string}
 */
function escapeString (str) {
  return str.replace(/([.+*?=^!:${}()[\]|\/\\])/g, '\\$1')
}

/**
 * Escape the capturing group by escaping special characters and meaning.
 *
 * @param  {string} group
 * @return {string}
 */
function escapeGroup (group) {
  return group.replace(/([=!:$\/()])/g, '\\$1')
}

/**
 * Attach the keys as a property of the regexp.
 *
 * @param  {!RegExp} re
 * @param  {Array}   keys
 * @return {!RegExp}
 */
function attachKeys (re, keys) {
  re.keys = keys;
  return re
}

/**
 * Get the flags for a regexp from the options.
 *
 * @param  {Object} options
 * @return {string}
 */
function flags (options) {
  return options.sensitive ? '' : 'i'
}

/**
 * Pull out keys from a regexp.
 *
 * @param  {!RegExp} path
 * @param  {!Array}  keys
 * @return {!RegExp}
 */
function regexpToRegexp (path, keys) {
  // Use a negative lookahead to match only capturing groups.
  var groups = path.source.match(/\((?!\?)/g);

  if (groups) {
    for (var i = 0; i < groups.length; i++) {
      keys.push({
        name: i,
        prefix: null,
        delimiter: null,
        optional: false,
        repeat: false,
        partial: false,
        asterisk: false,
        pattern: null
      });
    }
  }

  return attachKeys(path, keys)
}

/**
 * Transform an array into a regexp.
 *
 * @param  {!Array}  path
 * @param  {Array}   keys
 * @param  {!Object} options
 * @return {!RegExp}
 */
function arrayToRegexp (path, keys, options) {
  var parts = [];

  for (var i = 0; i < path.length; i++) {
    parts.push(pathToRegexp(path[i], keys, options).source);
  }

  var regexp = new RegExp('(?:' + parts.join('|') + ')', flags(options));

  return attachKeys(regexp, keys)
}

/**
 * Create a path regexp from string input.
 *
 * @param  {string}  path
 * @param  {!Array}  keys
 * @param  {!Object} options
 * @return {!RegExp}
 */
function stringToRegexp (path, keys, options) {
  return tokensToRegExp(parse(path, options), keys, options)
}

/**
 * Expose a function for taking tokens and returning a RegExp.
 *
 * @param  {!Array}          tokens
 * @param  {(Array|Object)=} keys
 * @param  {Object=}         options
 * @return {!RegExp}
 */
function tokensToRegExp (tokens, keys, options) {
  if (!index$1(keys)) {
    options = /** @type {!Object} */ (keys || options);
    keys = [];
  }

  options = options || {};

  var strict = options.strict;
  var end = options.end !== false;
  var route = '';

  // Iterate over the tokens and create our regexp string.
  for (var i = 0; i < tokens.length; i++) {
    var token = tokens[i];

    if (typeof token === 'string') {
      route += escapeString(token);
    } else {
      var prefix = escapeString(token.prefix);
      var capture = '(?:' + token.pattern + ')';

      keys.push(token);

      if (token.repeat) {
        capture += '(?:' + prefix + capture + ')*';
      }

      if (token.optional) {
        if (!token.partial) {
          capture = '(?:' + prefix + '(' + capture + '))?';
        } else {
          capture = prefix + '(' + capture + ')?';
        }
      } else {
        capture = prefix + '(' + capture + ')';
      }

      route += capture;
    }
  }

  var delimiter = escapeString(options.delimiter || '/');
  var endsWithDelimiter = route.slice(-delimiter.length) === delimiter;

  // In non-strict mode we allow a slash at the end of match. If the path to
  // match already ends with a slash, we remove it for consistency. The slash
  // is valid at the end of a path match, not in the middle. This is important
  // in non-ending mode, where "/test/" shouldn't match "/test//route".
  if (!strict) {
    route = (endsWithDelimiter ? route.slice(0, -delimiter.length) : route) + '(?:' + delimiter + '(?=$))?';
  }

  if (end) {
    route += '$';
  } else {
    // In non-ending mode, we need the capturing groups to match as much as
    // possible by using a positive lookahead to the end or next path segment.
    route += strict && endsWithDelimiter ? '' : '(?=' + delimiter + '|$)';
  }

  return attachKeys(new RegExp('^' + route, flags(options)), keys)
}

/**
 * Normalize the given path string, returning a regular expression.
 *
 * An empty array can be passed in for the keys, which will hold the
 * placeholder key descriptions. For example, using `/user/:id`, `keys` will
 * contain `[{ name: 'id', delimiter: '/', optional: false, repeat: false }]`.
 *
 * @param  {(string|RegExp|Array)} path
 * @param  {(Array|Object)=}       keys
 * @param  {Object=}               options
 * @return {!RegExp}
 */
function pathToRegexp (path, keys, options) {
  if (!index$1(keys)) {
    options = /** @type {!Object} */ (keys || options);
    keys = [];
  }

  options = options || {};

  if (path instanceof RegExp) {
    return regexpToRegexp(path, /** @type {!Array} */ (keys))
  }

  if (index$1(path)) {
    return arrayToRegexp(/** @type {!Array} */ (path), /** @type {!Array} */ (keys), options)
  }

  return stringToRegexp(/** @type {string} */ (path), /** @type {!Array} */ (keys), options)
}

index.parse = parse_1;
index.compile = compile_1;
index.tokensToFunction = tokensToFunction_1;
index.tokensToRegExp = tokensToRegExp_1;

/*  */

var regexpCompileCache = Object.create(null);

function fillParams (
  path,
  params,
  routeMsg
) {
  try {
    var filler =
      regexpCompileCache[path] ||
      (regexpCompileCache[path] = index.compile(path));
    return filler(params || {}, { pretty: true })
  } catch (e) {
    if (process.env.NODE_ENV !== 'production') {
      warn(false, ("missing param for " + routeMsg + ": " + (e.message)));
    }
    return ''
  }
}

/*  */

function createRouteMap (
  routes,
  oldPathList,
  oldPathMap,
  oldNameMap
) {
  // the path list is used to control path matching priority
  var pathList = oldPathList || [];
  var pathMap = oldPathMap || Object.create(null);
  var nameMap = oldNameMap || Object.create(null);

  routes.forEach(function (route) {
    addRouteRecord(pathList, pathMap, nameMap, route);
  });

  // ensure wildcard routes are always at the end
  for (var i = 0, l = pathList.length; i < l; i++) {
    if (pathList[i] === '*') {
      pathList.push(pathList.splice(i, 1)[0]);
      l--;
      i--;
    }
  }

  return {
    pathList: pathList,
    pathMap: pathMap,
    nameMap: nameMap
  }
}

function addRouteRecord (
  pathList,
  pathMap,
  nameMap,
  route,
  parent,
  matchAs
) {
  var path = route.path;
  var name = route.name;
  if (process.env.NODE_ENV !== 'production') {
    assert(path != null, "\"path\" is required in a route configuration.");
    assert(
      typeof route.component !== 'string',
      "route config \"component\" for path: " + (String(path || name)) + " cannot be a " +
      "string id. Use an actual component instead."
    );
  }

  var normalizedPath = normalizePath(path, parent);
  var record = {
    path: normalizedPath,
    regex: compileRouteRegex(normalizedPath),
    components: route.components || { default: route.component },
    instances: {},
    name: name,
    parent: parent,
    matchAs: matchAs,
    redirect: route.redirect,
    beforeEnter: route.beforeEnter,
    meta: route.meta || {},
    props: route.props == null
      ? {}
      : route.components
        ? route.props
        : { default: route.props }
  };

  if (route.children) {
    // Warn if route is named and has a default child route.
    // If users navigate to this route by name, the default child will
    // not be rendered (GH Issue #629)
    if (process.env.NODE_ENV !== 'production') {
      if (route.name && route.children.some(function (child) { return /^\/?$/.test(child.path); })) {
        warn(
          false,
          "Named Route '" + (route.name) + "' has a default child route. " +
          "When navigating to this named route (:to=\"{name: '" + (route.name) + "'\"), " +
          "the default child route will not be rendered. Remove the name from " +
          "this route and use the name of the default child route for named " +
          "links instead."
        );
      }
    }
    route.children.forEach(function (child) {
      var childMatchAs = matchAs
        ? cleanPath((matchAs + "/" + (child.path)))
        : undefined;
      addRouteRecord(pathList, pathMap, nameMap, child, record, childMatchAs);
    });
  }

  if (route.alias !== undefined) {
    if (Array.isArray(route.alias)) {
      route.alias.forEach(function (alias) {
        var aliasRoute = {
          path: alias,
          children: route.children
        };
        addRouteRecord(pathList, pathMap, nameMap, aliasRoute, parent, record.path);
      });
    } else {
      var aliasRoute = {
        path: route.alias,
        children: route.children
      };
      addRouteRecord(pathList, pathMap, nameMap, aliasRoute, parent, record.path);
    }
  }

  if (!pathMap[record.path]) {
    pathList.push(record.path);
    pathMap[record.path] = record;
  }

  if (name) {
    if (!nameMap[name]) {
      nameMap[name] = record;
    } else if (process.env.NODE_ENV !== 'production' && !matchAs) {
      warn(
        false,
        "Duplicate named routes definition: " +
        "{ name: \"" + name + "\", path: \"" + (record.path) + "\" }"
      );
    }
  }
}

function compileRouteRegex (path) {
  var regex = index(path);
  if (process.env.NODE_ENV !== 'production') {
    var keys = {};
    regex.keys.forEach(function (key) {
      warn(!keys[key.name], ("Duplicate param keys in route with path: \"" + path + "\""));
      keys[key.name] = true;
    });
  }
  return regex
}

function normalizePath (path, parent) {
  path = path.replace(/\/$/, '');
  if (path[0] === '/') { return path }
  if (parent == null) { return path }
  return cleanPath(((parent.path) + "/" + path))
}

/*  */


function normalizeLocation (
  raw,
  current,
  append,
  router
) {
  var next = typeof raw === 'string' ? { path: raw } : raw;
  // named target
  if (next.name || next._normalized) {
    return next
  }

  // relative params
  if (!next.path && next.params && current) {
    next = assign({}, next);
    next._normalized = true;
    var params = assign(assign({}, current.params), next.params);
    if (current.name) {
      next.name = current.name;
      next.params = params;
    } else if (current.matched) {
      var rawPath = current.matched[current.matched.length - 1].path;
      next.path = fillParams(rawPath, params, ("path " + (current.path)));
    } else if (process.env.NODE_ENV !== 'production') {
      warn(false, "relative params navigation requires a current route.");
    }
    return next
  }

  var parsedPath = parsePath(next.path || '');
  var basePath = (current && current.path) || '/';
  var path = parsedPath.path
    ? resolvePath(parsedPath.path, basePath, append || next.append)
    : basePath;

  var query = resolveQuery(
    parsedPath.query,
    next.query,
    router && router.options.parseQuery
  );

  var hash = next.hash || parsedPath.hash;
  if (hash && hash.charAt(0) !== '#') {
    hash = "#" + hash;
  }

  return {
    _normalized: true,
    path: path,
    query: query,
    hash: hash
  }
}

function assign (a, b) {
  for (var key in b) {
    a[key] = b[key];
  }
  return a
}

/*  */


function createMatcher (
  routes,
  router
) {
  var ref = createRouteMap(routes);
  var pathList = ref.pathList;
  var pathMap = ref.pathMap;
  var nameMap = ref.nameMap;

  function addRoutes (routes) {
    createRouteMap(routes, pathList, pathMap, nameMap);
  }

  function match (
    raw,
    currentRoute,
    redirectedFrom
  ) {
    var location = normalizeLocation(raw, currentRoute, false, router);
    var name = location.name;

    if (name) {
      var record = nameMap[name];
      if (process.env.NODE_ENV !== 'production') {
        warn(record, ("Route with name '" + name + "' does not exist"));
      }
      var paramNames = record.regex.keys
        .filter(function (key) { return !key.optional; })
        .map(function (key) { return key.name; });

      if (typeof location.params !== 'object') {
        location.params = {};
      }

      if (currentRoute && typeof currentRoute.params === 'object') {
        for (var key in currentRoute.params) {
          if (!(key in location.params) && paramNames.indexOf(key) > -1) {
            location.params[key] = currentRoute.params[key];
          }
        }
      }

      if (record) {
        location.path = fillParams(record.path, location.params, ("named route \"" + name + "\""));
        return _createRoute(record, location, redirectedFrom)
      }
    } else if (location.path) {
      location.params = {};
      for (var i = 0; i < pathList.length; i++) {
        var path = pathList[i];
        var record$1 = pathMap[path];
        if (matchRoute(record$1.regex, location.path, location.params)) {
          return _createRoute(record$1, location, redirectedFrom)
        }
      }
    }
    // no match
    return _createRoute(null, location)
  }

  function redirect (
    record,
    location
  ) {
    var originalRedirect = record.redirect;
    var redirect = typeof originalRedirect === 'function'
        ? originalRedirect(createRoute(record, location, null, router))
        : originalRedirect;

    if (typeof redirect === 'string') {
      redirect = { path: redirect };
    }

    if (!redirect || typeof redirect !== 'object') {
      if (process.env.NODE_ENV !== 'production') {
        warn(
          false, ("invalid redirect option: " + (JSON.stringify(redirect)))
        );
      }
      return _createRoute(null, location)
    }

    var re = redirect;
    var name = re.name;
    var path = re.path;
    var query = location.query;
    var hash = location.hash;
    var params = location.params;
    query = re.hasOwnProperty('query') ? re.query : query;
    hash = re.hasOwnProperty('hash') ? re.hash : hash;
    params = re.hasOwnProperty('params') ? re.params : params;

    if (name) {
      // resolved named direct
      var targetRecord = nameMap[name];
      if (process.env.NODE_ENV !== 'production') {
        assert(targetRecord, ("redirect failed: named route \"" + name + "\" not found."));
      }
      return match({
        _normalized: true,
        name: name,
        query: query,
        hash: hash,
        params: params
      }, undefined, location)
    } else if (path) {
      // 1. resolve relative redirect
      var rawPath = resolveRecordPath(path, record);
      // 2. resolve params
      var resolvedPath = fillParams(rawPath, params, ("redirect route with path \"" + rawPath + "\""));
      // 3. rematch with existing query and hash
      return match({
        _normalized: true,
        path: resolvedPath,
        query: query,
        hash: hash
      }, undefined, location)
    } else {
      if (process.env.NODE_ENV !== 'production') {
        warn(false, ("invalid redirect option: " + (JSON.stringify(redirect))));
      }
      return _createRoute(null, location)
    }
  }

  function alias (
    record,
    location,
    matchAs
  ) {
    var aliasedPath = fillParams(matchAs, location.params, ("aliased route with path \"" + matchAs + "\""));
    var aliasedMatch = match({
      _normalized: true,
      path: aliasedPath
    });
    if (aliasedMatch) {
      var matched = aliasedMatch.matched;
      var aliasedRecord = matched[matched.length - 1];
      location.params = aliasedMatch.params;
      return _createRoute(aliasedRecord, location)
    }
    return _createRoute(null, location)
  }

  function _createRoute (
    record,
    location,
    redirectedFrom
  ) {
    if (record && record.redirect) {
      return redirect(record, redirectedFrom || location)
    }
    if (record && record.matchAs) {
      return alias(record, location, record.matchAs)
    }
    return createRoute(record, location, redirectedFrom, router)
  }

  return {
    match: match,
    addRoutes: addRoutes
  }
}

function matchRoute (
  regex,
  path,
  params
) {
  var m = path.match(regex);

  if (!m) {
    return false
  } else if (!params) {
    return true
  }

  for (var i = 1, len = m.length; i < len; ++i) {
    var key = regex.keys[i - 1];
    var val = typeof m[i] === 'string' ? decodeURIComponent(m[i]) : m[i];
    if (key) {
      params[key.name] = val;
    }
  }

  return true
}

function resolveRecordPath (path, record) {
  return resolvePath(path, record.parent ? record.parent.path : '/', true)
}

/*  */


var positionStore = Object.create(null);

function setupScroll () {
  window.addEventListener('popstate', function (e) {
    saveScrollPosition();
    if (e.state && e.state.key) {
      setStateKey(e.state.key);
    }
  });
}

function handleScroll (
  router,
  to,
  from,
  isPop
) {
  if (!router.app) {
    return
  }

  var behavior = router.options.scrollBehavior;
  if (!behavior) {
    return
  }

  if (process.env.NODE_ENV !== 'production') {
    assert(typeof behavior === 'function', "scrollBehavior must be a function");
  }

  // wait until re-render finishes before scrolling
  router.app.$nextTick(function () {
    var position = getScrollPosition();
    var shouldScroll = behavior(to, from, isPop ? position : null);
    if (!shouldScroll) {
      return
    }
    var isObject = typeof shouldScroll === 'object';
    if (isObject && typeof shouldScroll.selector === 'string') {
      var el = document.querySelector(shouldScroll.selector);
      if (el) {
        position = getElementPosition(el);
      } else if (isValidPosition(shouldScroll)) {
        position = normalizePosition(shouldScroll);
      }
    } else if (isObject && isValidPosition(shouldScroll)) {
      position = normalizePosition(shouldScroll);
    }

    if (position) {
      window.scrollTo(position.x, position.y);
    }
  });
}

function saveScrollPosition () {
  var key = getStateKey();
  if (key) {
    positionStore[key] = {
      x: window.pageXOffset,
      y: window.pageYOffset
    };
  }
}

function getScrollPosition () {
  var key = getStateKey();
  if (key) {
    return positionStore[key]
  }
}

function getElementPosition (el) {
  var docEl = document.documentElement;
  var docRect = docEl.getBoundingClientRect();
  var elRect = el.getBoundingClientRect();
  return {
    x: elRect.left - docRect.left,
    y: elRect.top - docRect.top
  }
}

function isValidPosition (obj) {
  return isNumber(obj.x) || isNumber(obj.y)
}

function normalizePosition (obj) {
  return {
    x: isNumber(obj.x) ? obj.x : window.pageXOffset,
    y: isNumber(obj.y) ? obj.y : window.pageYOffset
  }
}

function isNumber (v) {
  return typeof v === 'number'
}

/*  */

var supportsPushState = inBrowser && (function () {
  var ua = window.navigator.userAgent;

  if (
    (ua.indexOf('Android 2.') !== -1 || ua.indexOf('Android 4.0') !== -1) &&
    ua.indexOf('Mobile Safari') !== -1 &&
    ua.indexOf('Chrome') === -1 &&
    ua.indexOf('Windows Phone') === -1
  ) {
    return false
  }

  return window.history && 'pushState' in window.history
})();

// use User Timing api (if present) for more accurate key precision
var Time = inBrowser && window.performance && window.performance.now
  ? window.performance
  : Date;

var _key = genKey();

function genKey () {
  return Time.now().toFixed(3)
}

function getStateKey () {
  return _key
}

function setStateKey (key) {
  _key = key;
}

function pushState (url, replace) {
  saveScrollPosition();
  // try...catch the pushState call to get around Safari
  // DOM Exception 18 where it limits to 100 pushState calls
  var history = window.history;
  try {
    if (replace) {
      history.replaceState({ key: _key }, '', url);
    } else {
      _key = genKey();
      history.pushState({ key: _key }, '', url);
    }
  } catch (e) {
    window.location[replace ? 'replace' : 'assign'](url);
  }
}

function replaceState (url) {
  pushState(url, true);
}

/*  */

function runQueue (queue, fn, cb) {
  var step = function (index) {
    if (index >= queue.length) {
      cb();
    } else {
      if (queue[index]) {
        fn(queue[index], function () {
          step(index + 1);
        });
      } else {
        step(index + 1);
      }
    }
  };
  step(0);
}

/*  */

var History = function History (router, base) {
  this.router = router;
  this.base = normalizeBase(base);
  // start with a route object that stands for "nowhere"
  this.current = START;
  this.pending = null;
  this.ready = false;
  this.readyCbs = [];
  this.readyErrorCbs = [];
  this.errorCbs = [];
};

History.prototype.listen = function listen (cb) {
  this.cb = cb;
};

History.prototype.onReady = function onReady (cb, errorCb) {
  if (this.ready) {
    cb();
  } else {
    this.readyCbs.push(cb);
    if (errorCb) {
      this.readyErrorCbs.push(errorCb);
    }
  }
};

History.prototype.onError = function onError (errorCb) {
  this.errorCbs.push(errorCb);
};

History.prototype.transitionTo = function transitionTo (location, onComplete, onAbort) {
    var this$1 = this;

  var route = this.router.match(location, this.current);
  this.confirmTransition(route, function () {
    this$1.updateRoute(route);
    onComplete && onComplete(route);
    this$1.ensureURL();

    // fire ready cbs once
    if (!this$1.ready) {
      this$1.ready = true;
      this$1.readyCbs.forEach(function (cb) { cb(route); });
    }
  }, function (err) {
    if (onAbort) {
      onAbort(err);
    }
    if (err && !this$1.ready) {
      this$1.ready = true;
      this$1.readyErrorCbs.forEach(function (cb) { cb(err); });
    }
  });
};

History.prototype.confirmTransition = function confirmTransition (route, onComplete, onAbort) {
    var this$1 = this;

  var current = this.current;
  var abort = function (err) {
    if (isError(err)) {
      if (this$1.errorCbs.length) {
        this$1.errorCbs.forEach(function (cb) { cb(err); });
      } else {
        warn(false, 'uncaught error during route navigation:');
        console.error(err);
      }
    }
    onAbort && onAbort(err);
  };
  if (
    isSameRoute(route, current) &&
    // in the case the route map has been dynamically appended to
    route.matched.length === current.matched.length
  ) {
    this.ensureURL();
    return abort()
  }

  var ref = resolveQueue(this.current.matched, route.matched);
    var updated = ref.updated;
    var deactivated = ref.deactivated;
    var activated = ref.activated;

  var queue = [].concat(
    // in-component leave guards
    extractLeaveGuards(deactivated),
    // global before hooks
    this.router.beforeHooks,
    // in-component update hooks
    extractUpdateHooks(updated),
    // in-config enter guards
    activated.map(function (m) { return m.beforeEnter; }),
    // async components
    resolveAsyncComponents(activated)
  );

  this.pending = route;
  var iterator = function (hook, next) {
    if (this$1.pending !== route) {
      return abort()
    }
    try {
      hook(route, current, function (to) {
        if (to === false || isError(to)) {
          // next(false) -> abort navigation, ensure current URL
          this$1.ensureURL(true);
          abort(to);
        } else if (
          typeof to === 'string' ||
          (typeof to === 'object' && (
            typeof to.path === 'string' ||
            typeof to.name === 'string'
          ))
        ) {
          // next('/') or next({ path: '/' }) -> redirect
          abort();
          if (typeof to === 'object' && to.replace) {
            this$1.replace(to);
          } else {
            this$1.push(to);
          }
        } else {
          // confirm transition and pass on the value
          next(to);
        }
      });
    } catch (e) {
      abort(e);
    }
  };

  runQueue(queue, iterator, function () {
    var postEnterCbs = [];
    var isValid = function () { return this$1.current === route; };
    // wait until async components are resolved before
    // extracting in-component enter guards
    var enterGuards = extractEnterGuards(activated, postEnterCbs, isValid);
    var queue = enterGuards.concat(this$1.router.resolveHooks);
    runQueue(queue, iterator, function () {
      if (this$1.pending !== route) {
        return abort()
      }
      this$1.pending = null;
      onComplete(route);
      if (this$1.router.app) {
        this$1.router.app.$nextTick(function () {
          postEnterCbs.forEach(function (cb) { cb(); });
        });
      }
    });
  });
};

History.prototype.updateRoute = function updateRoute (route) {
  var prev = this.current;
  this.current = route;
  this.cb && this.cb(route);
  this.router.afterHooks.forEach(function (hook) {
    hook && hook(route, prev);
  });
};

function normalizeBase (base) {
  if (!base) {
    if (inBrowser) {
      // respect <base> tag
      var baseEl = document.querySelector('base');
      base = (baseEl && baseEl.getAttribute('href')) || '/';
    } else {
      base = '/';
    }
  }
  // make sure there's the starting slash
  if (base.charAt(0) !== '/') {
    base = '/' + base;
  }
  // remove trailing slash
  return base.replace(/\/$/, '')
}

function resolveQueue (
  current,
  next
) {
  var i;
  var max = Math.max(current.length, next.length);
  for (i = 0; i < max; i++) {
    if (current[i] !== next[i]) {
      break
    }
  }
  return {
    updated: next.slice(0, i),
    activated: next.slice(i),
    deactivated: current.slice(i)
  }
}

function extractGuards (
  records,
  name,
  bind,
  reverse
) {
  var guards = flatMapComponents(records, function (def, instance, match, key) {
    var guard = extractGuard(def, name);
    if (guard) {
      return Array.isArray(guard)
        ? guard.map(function (guard) { return bind(guard, instance, match, key); })
        : bind(guard, instance, match, key)
    }
  });
  return flatten(reverse ? guards.reverse() : guards)
}

function extractGuard (
  def,
  key
) {
  if (typeof def !== 'function') {
    // extend now so that global mixins are applied.
    def = _Vue.extend(def);
  }
  return def.options[key]
}

function extractLeaveGuards (deactivated) {
  return extractGuards(deactivated, 'beforeRouteLeave', bindGuard, true)
}

function extractUpdateHooks (updated) {
  return extractGuards(updated, 'beforeRouteUpdate', bindGuard)
}

function bindGuard (guard, instance) {
  if (instance) {
    return function boundRouteGuard () {
      return guard.apply(instance, arguments)
    }
  }
}

function extractEnterGuards (
  activated,
  cbs,
  isValid
) {
  return extractGuards(activated, 'beforeRouteEnter', function (guard, _, match, key) {
    return bindEnterGuard(guard, match, key, cbs, isValid)
  })
}

function bindEnterGuard (
  guard,
  match,
  key,
  cbs,
  isValid
) {
  return function routeEnterGuard (to, from, next) {
    return guard(to, from, function (cb) {
      next(cb);
      if (typeof cb === 'function') {
        cbs.push(function () {
          // #750
          // if a router-view is wrapped with an out-in transition,
          // the instance may not have been registered at this time.
          // we will need to poll for registration until current route
          // is no longer valid.
          poll(cb, match.instances, key, isValid);
        });
      }
    })
  }
}

function poll (
  cb, // somehow flow cannot infer this is a function
  instances,
  key,
  isValid
) {
  if (instances[key]) {
    cb(instances[key]);
  } else if (isValid()) {
    setTimeout(function () {
      poll(cb, instances, key, isValid);
    }, 16);
  }
}

function resolveAsyncComponents (matched) {
  return function (to, from, next) {
    var hasAsync = false;
    var pending = 0;
    var error = null;

    flatMapComponents(matched, function (def, _, match, key) {
      // if it's a function and doesn't have cid attached,
      // assume it's an async component resolve function.
      // we are not using Vue's default async resolving mechanism because
      // we want to halt the navigation until the incoming component has been
      // resolved.
      if (typeof def === 'function' && def.cid === undefined) {
        hasAsync = true;
        pending++;

        var resolve = once(function (resolvedDef) {
          // save resolved on async factory in case it's used elsewhere
          def.resolved = typeof resolvedDef === 'function'
            ? resolvedDef
            : _Vue.extend(resolvedDef);
          match.components[key] = resolvedDef;
          pending--;
          if (pending <= 0) {
            next();
          }
        });

        var reject = once(function (reason) {
          var msg = "Failed to resolve async component " + key + ": " + reason;
          process.env.NODE_ENV !== 'production' && warn(false, msg);
          if (!error) {
            error = isError(reason)
              ? reason
              : new Error(msg);
            next(error);
          }
        });

        var res;
        try {
          res = def(resolve, reject);
        } catch (e) {
          reject(e);
        }
        if (res) {
          if (typeof res.then === 'function') {
            res.then(resolve, reject);
          } else {
            // new syntax in Vue 2.3
            var comp = res.component;
            if (comp && typeof comp.then === 'function') {
              comp.then(resolve, reject);
            }
          }
        }
      }
    });

    if (!hasAsync) { next(); }
  }
}

function flatMapComponents (
  matched,
  fn
) {
  return flatten(matched.map(function (m) {
    return Object.keys(m.components).map(function (key) { return fn(
      m.components[key],
      m.instances[key],
      m, key
    ); })
  }))
}

function flatten (arr) {
  return Array.prototype.concat.apply([], arr)
}

// in Webpack 2, require.ensure now also returns a Promise
// so the resolve/reject functions may get called an extra time
// if the user uses an arrow function shorthand that happens to
// return that Promise.
function once (fn) {
  var called = false;
  return function () {
    if (called) { return }
    called = true;
    return fn.apply(this, arguments)
  }
}

function isError (err) {
  return Object.prototype.toString.call(err).indexOf('Error') > -1
}

/*  */


var HTML5History = (function (History$$1) {
  function HTML5History (router, base) {
    var this$1 = this;

    History$$1.call(this, router, base);

    var expectScroll = router.options.scrollBehavior;

    if (expectScroll) {
      setupScroll();
    }

    window.addEventListener('popstate', function (e) {
      this$1.transitionTo(getLocation(this$1.base), function (route) {
        if (expectScroll) {
          handleScroll(router, route, this$1.current, true);
        }
      });
    });
  }

  if ( History$$1 ) HTML5History.__proto__ = History$$1;
  HTML5History.prototype = Object.create( History$$1 && History$$1.prototype );
  HTML5History.prototype.constructor = HTML5History;

  HTML5History.prototype.go = function go (n) {
    window.history.go(n);
  };

  HTML5History.prototype.push = function push (location, onComplete, onAbort) {
    var this$1 = this;

    var ref = this;
    var fromRoute = ref.current;
    this.transitionTo(location, function (route) {
      pushState(cleanPath(this$1.base + route.fullPath));
      handleScroll(this$1.router, route, fromRoute, false);
      onComplete && onComplete(route);
    }, onAbort);
  };

  HTML5History.prototype.replace = function replace (location, onComplete, onAbort) {
    var this$1 = this;

    var ref = this;
    var fromRoute = ref.current;
    this.transitionTo(location, function (route) {
      replaceState(cleanPath(this$1.base + route.fullPath));
      handleScroll(this$1.router, route, fromRoute, false);
      onComplete && onComplete(route);
    }, onAbort);
  };

  HTML5History.prototype.ensureURL = function ensureURL (push) {
    if (getLocation(this.base) !== this.current.fullPath) {
      var current = cleanPath(this.base + this.current.fullPath);
      push ? pushState(current) : replaceState(current);
    }
  };

  HTML5History.prototype.getCurrentLocation = function getCurrentLocation () {
    return getLocation(this.base)
  };

  return HTML5History;
}(History));

function getLocation (base) {
  var path = window.location.pathname;
  if (base && path.indexOf(base) === 0) {
    path = path.slice(base.length);
  }
  return (path || '/') + window.location.search + window.location.hash
}

/*  */


var HashHistory = (function (History$$1) {
  function HashHistory (router, base, fallback) {
    History$$1.call(this, router, base);
    // check history fallback deeplinking
    if (fallback && checkFallback(this.base)) {
      return
    }
    ensureSlash();
  }

  if ( History$$1 ) HashHistory.__proto__ = History$$1;
  HashHistory.prototype = Object.create( History$$1 && History$$1.prototype );
  HashHistory.prototype.constructor = HashHistory;

  // this is delayed until the app mounts
  // to avoid the hashchange listener being fired too early
  HashHistory.prototype.setupListeners = function setupListeners () {
    var this$1 = this;

    window.addEventListener('hashchange', function () {
      if (!ensureSlash()) {
        return
      }
      this$1.transitionTo(getHash(), function (route) {
        replaceHash(route.fullPath);
      });
    });
  };

  HashHistory.prototype.push = function push (location, onComplete, onAbort) {
    this.transitionTo(location, function (route) {
      pushHash(route.fullPath);
      onComplete && onComplete(route);
    }, onAbort);
  };

  HashHistory.prototype.replace = function replace (location, onComplete, onAbort) {
    this.transitionTo(location, function (route) {
      replaceHash(route.fullPath);
      onComplete && onComplete(route);
    }, onAbort);
  };

  HashHistory.prototype.go = function go (n) {
    window.history.go(n);
  };

  HashHistory.prototype.ensureURL = function ensureURL (push) {
    var current = this.current.fullPath;
    if (getHash() !== current) {
      push ? pushHash(current) : replaceHash(current);
    }
  };

  HashHistory.prototype.getCurrentLocation = function getCurrentLocation () {
    return getHash()
  };

  return HashHistory;
}(History));

function checkFallback (base) {
  var location = getLocation(base);
  if (!/^\/#/.test(location)) {
    window.location.replace(
      cleanPath(base + '/#' + location)
    );
    return true
  }
}

function ensureSlash () {
  var path = getHash();
  if (path.charAt(0) === '/') {
    return true
  }
  replaceHash('/' + path);
  return false
}

function getHash () {
  // We can't use window.location.hash here because it's not
  // consistent across browsers - Firefox will pre-decode it!
  var href = window.location.href;
  var index = href.indexOf('#');
  return index === -1 ? '' : href.slice(index + 1)
}

function pushHash (path) {
  window.location.hash = path;
}

function replaceHash (path) {
  var i = window.location.href.indexOf('#');
  window.location.replace(
    window.location.href.slice(0, i >= 0 ? i : 0) + '#' + path
  );
}

/*  */


var AbstractHistory = (function (History$$1) {
  function AbstractHistory (router, base) {
    History$$1.call(this, router, base);
    this.stack = [];
    this.index = -1;
  }

  if ( History$$1 ) AbstractHistory.__proto__ = History$$1;
  AbstractHistory.prototype = Object.create( History$$1 && History$$1.prototype );
  AbstractHistory.prototype.constructor = AbstractHistory;

  AbstractHistory.prototype.push = function push (location, onComplete, onAbort) {
    var this$1 = this;

    this.transitionTo(location, function (route) {
      this$1.stack = this$1.stack.slice(0, this$1.index + 1).concat(route);
      this$1.index++;
      onComplete && onComplete(route);
    }, onAbort);
  };

  AbstractHistory.prototype.replace = function replace (location, onComplete, onAbort) {
    var this$1 = this;

    this.transitionTo(location, function (route) {
      this$1.stack = this$1.stack.slice(0, this$1.index).concat(route);
      onComplete && onComplete(route);
    }, onAbort);
  };

  AbstractHistory.prototype.go = function go (n) {
    var this$1 = this;

    var targetIndex = this.index + n;
    if (targetIndex < 0 || targetIndex >= this.stack.length) {
      return
    }
    var route = this.stack[targetIndex];
    this.confirmTransition(route, function () {
      this$1.index = targetIndex;
      this$1.updateRoute(route);
    });
  };

  AbstractHistory.prototype.getCurrentLocation = function getCurrentLocation () {
    var current = this.stack[this.stack.length - 1];
    return current ? current.fullPath : '/'
  };

  AbstractHistory.prototype.ensureURL = function ensureURL () {
    // noop
  };

  return AbstractHistory;
}(History));

/*  */

var VueRouter = function VueRouter (options) {
  if ( options === void 0 ) options = {};

  this.app = null;
  this.apps = [];
  this.options = options;
  this.beforeHooks = [];
  this.resolveHooks = [];
  this.afterHooks = [];
  this.matcher = createMatcher(options.routes || [], this);

  var mode = options.mode || 'hash';
  this.fallback = mode === 'history' && !supportsPushState;
  if (this.fallback) {
    mode = 'hash';
  }
  if (!inBrowser) {
    mode = 'abstract';
  }
  this.mode = mode;

  switch (mode) {
    case 'history':
      this.history = new HTML5History(this, options.base);
      break
    case 'hash':
      this.history = new HashHistory(this, options.base, this.fallback);
      break
    case 'abstract':
      this.history = new AbstractHistory(this, options.base);
      break
    default:
      if (process.env.NODE_ENV !== 'production') {
        assert(false, ("invalid mode: " + mode));
      }
  }
};

var prototypeAccessors = { currentRoute: {} };

VueRouter.prototype.match = function match (
  raw,
  current,
  redirectedFrom
) {
  return this.matcher.match(raw, current, redirectedFrom)
};

prototypeAccessors.currentRoute.get = function () {
  return this.history && this.history.current
};

VueRouter.prototype.init = function init (app /* Vue component instance */) {
    var this$1 = this;

  process.env.NODE_ENV !== 'production' && assert(
    install.installed,
    "not installed. Make sure to call `Vue.use(VueRouter)` " +
    "before creating root instance."
  );

  this.apps.push(app);

  // main app already initialized.
  if (this.app) {
    return
  }

  this.app = app;

  var history = this.history;

  if (history instanceof HTML5History) {
    history.transitionTo(history.getCurrentLocation());
  } else if (history instanceof HashHistory) {
    var setupHashListener = function () {
      history.setupListeners();
    };
    history.transitionTo(
      history.getCurrentLocation(),
      setupHashListener,
      setupHashListener
    );
  }

  history.listen(function (route) {
    this$1.apps.forEach(function (app) {
      app._route = route;
    });
  });
};

VueRouter.prototype.beforeEach = function beforeEach (fn) {
  return registerHook(this.beforeHooks, fn)
};

VueRouter.prototype.beforeResolve = function beforeResolve (fn) {
  return registerHook(this.resolveHooks, fn)
};

VueRouter.prototype.afterEach = function afterEach (fn) {
  return registerHook(this.afterHooks, fn)
};

VueRouter.prototype.onReady = function onReady (cb, errorCb) {
  this.history.onReady(cb, errorCb);
};

VueRouter.prototype.onError = function onError (errorCb) {
  this.history.onError(errorCb);
};

VueRouter.prototype.push = function push (location, onComplete, onAbort) {
  this.history.push(location, onComplete, onAbort);
};

VueRouter.prototype.replace = function replace (location, onComplete, onAbort) {
  this.history.replace(location, onComplete, onAbort);
};

VueRouter.prototype.go = function go (n) {
  this.history.go(n);
};

VueRouter.prototype.back = function back () {
  this.go(-1);
};

VueRouter.prototype.forward = function forward () {
  this.go(1);
};

VueRouter.prototype.getMatchedComponents = function getMatchedComponents (to) {
  var route = to
    ? to.matched
      ? to
      : this.resolve(to).route
    : this.currentRoute;
  if (!route) {
    return []
  }
  return [].concat.apply([], route.matched.map(function (m) {
    return Object.keys(m.components).map(function (key) {
      return m.components[key]
    })
  }))
};

VueRouter.prototype.resolve = function resolve (
  to,
  current,
  append
) {
  var location = normalizeLocation(
    to,
    current || this.history.current,
    append,
    this
  );
  var route = this.match(location, current);
  var fullPath = route.redirectedFrom || route.fullPath;
  var base = this.history.base;
  var href = createHref(base, fullPath, this.mode);
  return {
    location: location,
    route: route,
    href: href,
    // for backwards compat
    normalizedTo: location,
    resolved: route
  }
};

VueRouter.prototype.addRoutes = function addRoutes (routes) {
  this.matcher.addRoutes(routes);
  if (this.history.current !== START) {
    this.history.transitionTo(this.history.getCurrentLocation());
  }
};

Object.defineProperties( VueRouter.prototype, prototypeAccessors );

function registerHook (list, fn) {
  list.push(fn);
  return function () {
    var i = list.indexOf(fn);
    if (i > -1) { list.splice(i, 1); }
  }
}

function createHref (base, fullPath, mode) {
  var path = mode === 'hash' ? '#' + fullPath : fullPath;
  return base ? cleanPath(base + '/' + path) : path
}

VueRouter.install = install;
VueRouter.version = '2.5.3';

if (inBrowser && window.Vue) {
  window.Vue.use(VueRouter);
}

/* harmony default export */ __webpack_exports__["default"] = VueRouter;

/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(11)))

/***/ }),
/* 13 */
/***/ (function(module, exports, __webpack_require__) {

var __vue_exports__, __vue_options__
var __vue_styles__ = []

/* script */
__vue_exports__ = __webpack_require__(30)
__vue_options__ = __vue_exports__ = __vue_exports__ || {}
if (
  typeof __vue_exports__.default === "object" ||
  typeof __vue_exports__.default === "function"
) {
if (Object.keys(__vue_exports__).some(function (key) { return key !== "default" && key !== "__esModule" })) {console.error("named exports are not supported in *.vue files.")}
__vue_options__ = __vue_exports__ = __vue_exports__.default
}
if (typeof __vue_options__ === "function") {
  __vue_options__ = __vue_options__.options
}
__vue_options__.__file = "/AliGitLab/qk-lightApp/src/components/article-elements/articleElement.vue"
__vue_options__.style = __vue_options__.style || {}
__vue_styles__.forEach(function (module) {
  for (var name in module) {
    __vue_options__.style[name] = module[name]
  }
})
if (typeof __register_static_styles__ === "function") {
  __register_static_styles__(__vue_options__._scopeId, __vue_styles__)
}

module.exports = __vue_exports__


/***/ }),
/* 14 */
/***/ (function(module, exports, __webpack_require__) {

var __vue_exports__, __vue_options__
var __vue_styles__ = []

/* styles */
__vue_styles__.push(__webpack_require__(47)
)

/* script */
__vue_exports__ = __webpack_require__(31)

/* template */
var __vue_template__ = __webpack_require__(62)
__vue_options__ = __vue_exports__ = __vue_exports__ || {}
if (
  typeof __vue_exports__.default === "object" ||
  typeof __vue_exports__.default === "function"
) {
if (Object.keys(__vue_exports__).some(function (key) { return key !== "default" && key !== "__esModule" })) {console.error("named exports are not supported in *.vue files.")}
__vue_options__ = __vue_exports__ = __vue_exports__.default
}
if (typeof __vue_options__ === "function") {
  __vue_options__ = __vue_options__.options
}
__vue_options__.__file = "/AliGitLab/qk-lightApp/src/components/article-elements/footer-element.vue"
__vue_options__.render = __vue_template__.render
__vue_options__.staticRenderFns = __vue_template__.staticRenderFns
__vue_options__._scopeId = "data-v-1960c4b5"
__vue_options__.style = __vue_options__.style || {}
__vue_styles__.forEach(function (module) {
  for (var name in module) {
    __vue_options__.style[name] = module[name]
  }
})
if (typeof __register_static_styles__ === "function") {
  __register_static_styles__(__vue_options__._scopeId, __vue_styles__)
}

module.exports = __vue_exports__


/***/ }),
/* 15 */
/***/ (function(module, exports, __webpack_require__) {

var __vue_exports__, __vue_options__
var __vue_styles__ = []

/* styles */
__vue_styles__.push(__webpack_require__(59)
)

/* script */
__vue_exports__ = __webpack_require__(32)

/* template */
var __vue_template__ = __webpack_require__(74)
__vue_options__ = __vue_exports__ = __vue_exports__ || {}
if (
  typeof __vue_exports__.default === "object" ||
  typeof __vue_exports__.default === "function"
) {
if (Object.keys(__vue_exports__).some(function (key) { return key !== "default" && key !== "__esModule" })) {console.error("named exports are not supported in *.vue files.")}
__vue_options__ = __vue_exports__ = __vue_exports__.default
}
if (typeof __vue_options__ === "function") {
  __vue_options__ = __vue_options__.options
}
__vue_options__.__file = "/AliGitLab/qk-lightApp/src/components/article-elements/header-element.vue"
__vue_options__.render = __vue_template__.render
__vue_options__.staticRenderFns = __vue_template__.staticRenderFns
__vue_options__._scopeId = "data-v-ef9dd2b2"
__vue_options__.style = __vue_options__.style || {}
__vue_styles__.forEach(function (module) {
  for (var name in module) {
    __vue_options__.style[name] = module[name]
  }
})
if (typeof __register_static_styles__ === "function") {
  __register_static_styles__(__vue_options__._scopeId, __vue_styles__)
}

module.exports = __vue_exports__


/***/ }),
/* 16 */
/***/ (function(module, exports, __webpack_require__) {

var __vue_exports__, __vue_options__
var __vue_styles__ = []

/* styles */
__vue_styles__.push(__webpack_require__(60)
)

/* script */
__vue_exports__ = __webpack_require__(33)

/* template */
var __vue_template__ = __webpack_require__(75)
__vue_options__ = __vue_exports__ = __vue_exports__ || {}
if (
  typeof __vue_exports__.default === "object" ||
  typeof __vue_exports__.default === "function"
) {
if (Object.keys(__vue_exports__).some(function (key) { return key !== "default" && key !== "__esModule" })) {console.error("named exports are not supported in *.vue files.")}
__vue_options__ = __vue_exports__ = __vue_exports__.default
}
if (typeof __vue_options__ === "function") {
  __vue_options__ = __vue_options__.options
}
__vue_options__.__file = "/AliGitLab/qk-lightApp/src/components/article-elements/image-element.vue"
__vue_options__.render = __vue_template__.render
__vue_options__.staticRenderFns = __vue_template__.staticRenderFns
__vue_options__._scopeId = "data-v-f8d46522"
__vue_options__.style = __vue_options__.style || {}
__vue_styles__.forEach(function (module) {
  for (var name in module) {
    __vue_options__.style[name] = module[name]
  }
})
if (typeof __register_static_styles__ === "function") {
  __register_static_styles__(__vue_options__._scopeId, __vue_styles__)
}

module.exports = __vue_exports__


/***/ }),
/* 17 */
/***/ (function(module, exports, __webpack_require__) {

var __vue_exports__, __vue_options__
var __vue_styles__ = []

/* styles */
__vue_styles__.push(__webpack_require__(49)
)

/* script */
__vue_exports__ = __webpack_require__(34)

/* template */
var __vue_template__ = __webpack_require__(64)
__vue_options__ = __vue_exports__ = __vue_exports__ || {}
if (
  typeof __vue_exports__.default === "object" ||
  typeof __vue_exports__.default === "function"
) {
if (Object.keys(__vue_exports__).some(function (key) { return key !== "default" && key !== "__esModule" })) {console.error("named exports are not supported in *.vue files.")}
__vue_options__ = __vue_exports__ = __vue_exports__.default
}
if (typeof __vue_options__ === "function") {
  __vue_options__ = __vue_options__.options
}
__vue_options__.__file = "/AliGitLab/qk-lightApp/src/components/article-elements/richtext-element.vue"
__vue_options__.render = __vue_template__.render
__vue_options__.staticRenderFns = __vue_template__.staticRenderFns
__vue_options__._scopeId = "data-v-2eb67163"
__vue_options__.style = __vue_options__.style || {}
__vue_styles__.forEach(function (module) {
  for (var name in module) {
    __vue_options__.style[name] = module[name]
  }
})
if (typeof __register_static_styles__ === "function") {
  __register_static_styles__(__vue_options__._scopeId, __vue_styles__)
}

module.exports = __vue_exports__


/***/ }),
/* 18 */
/***/ (function(module, exports, __webpack_require__) {

var __vue_exports__, __vue_options__
var __vue_styles__ = []

/* styles */
__vue_styles__.push(__webpack_require__(48)
)

/* script */
__vue_exports__ = __webpack_require__(35)

/* template */
var __vue_template__ = __webpack_require__(63)
__vue_options__ = __vue_exports__ = __vue_exports__ || {}
if (
  typeof __vue_exports__.default === "object" ||
  typeof __vue_exports__.default === "function"
) {
if (Object.keys(__vue_exports__).some(function (key) { return key !== "default" && key !== "__esModule" })) {console.error("named exports are not supported in *.vue files.")}
__vue_options__ = __vue_exports__ = __vue_exports__.default
}
if (typeof __vue_options__ === "function") {
  __vue_options__ = __vue_options__.options
}
__vue_options__.__file = "/AliGitLab/qk-lightApp/src/components/article-elements/table-element.vue"
__vue_options__.render = __vue_template__.render
__vue_options__.staticRenderFns = __vue_template__.staticRenderFns
__vue_options__._scopeId = "data-v-2b3c4b62"
__vue_options__.style = __vue_options__.style || {}
__vue_styles__.forEach(function (module) {
  for (var name in module) {
    __vue_options__.style[name] = module[name]
  }
})
if (typeof __register_static_styles__ === "function") {
  __register_static_styles__(__vue_options__._scopeId, __vue_styles__)
}

module.exports = __vue_exports__


/***/ }),
/* 19 */
/***/ (function(module, exports, __webpack_require__) {

var __vue_exports__, __vue_options__
var __vue_styles__ = []

/* styles */
__vue_styles__.push(__webpack_require__(52)
)

/* script */
__vue_exports__ = __webpack_require__(36)

/* template */
var __vue_template__ = __webpack_require__(67)
__vue_options__ = __vue_exports__ = __vue_exports__ || {}
if (
  typeof __vue_exports__.default === "object" ||
  typeof __vue_exports__.default === "function"
) {
if (Object.keys(__vue_exports__).some(function (key) { return key !== "default" && key !== "__esModule" })) {console.error("named exports are not supported in *.vue files.")}
__vue_options__ = __vue_exports__ = __vue_exports__.default
}
if (typeof __vue_options__ === "function") {
  __vue_options__ = __vue_options__.options
}
__vue_options__.__file = "/AliGitLab/qk-lightApp/src/components/article-elements/text-element.vue"
__vue_options__.render = __vue_template__.render
__vue_options__.staticRenderFns = __vue_template__.staticRenderFns
__vue_options__._scopeId = "data-v-47e7fbf2"
__vue_options__.style = __vue_options__.style || {}
__vue_styles__.forEach(function (module) {
  for (var name in module) {
    __vue_options__.style[name] = module[name]
  }
})
if (typeof __register_static_styles__ === "function") {
  __register_static_styles__(__vue_options__._scopeId, __vue_styles__)
}

module.exports = __vue_exports__


/***/ }),
/* 20 */
/***/ (function(module, exports, __webpack_require__) {

var __vue_exports__, __vue_options__
var __vue_styles__ = []

/* styles */
__vue_styles__.push(__webpack_require__(55)
)

/* script */
__vue_exports__ = __webpack_require__(37)

/* template */
var __vue_template__ = __webpack_require__(70)
__vue_options__ = __vue_exports__ = __vue_exports__ || {}
if (
  typeof __vue_exports__.default === "object" ||
  typeof __vue_exports__.default === "function"
) {
if (Object.keys(__vue_exports__).some(function (key) { return key !== "default" && key !== "__esModule" })) {console.error("named exports are not supported in *.vue files.")}
__vue_options__ = __vue_exports__ = __vue_exports__.default
}
if (typeof __vue_options__ === "function") {
  __vue_options__ = __vue_options__.options
}
__vue_options__.__file = "/AliGitLab/qk-lightApp/src/components/article-elements/video-element.vue"
__vue_options__.render = __vue_template__.render
__vue_options__.staticRenderFns = __vue_template__.staticRenderFns
__vue_options__._scopeId = "data-v-9e38eee2"
__vue_options__.style = __vue_options__.style || {}
__vue_styles__.forEach(function (module) {
  for (var name in module) {
    __vue_options__.style[name] = module[name]
  }
})
if (typeof __register_static_styles__ === "function") {
  __register_static_styles__(__vue_options__._scopeId, __vue_styles__)
}

module.exports = __vue_exports__


/***/ }),
/* 21 */
/***/ (function(module, exports, __webpack_require__) {

var __vue_exports__, __vue_options__
var __vue_styles__ = []

/* styles */
__vue_styles__.push(__webpack_require__(53)
)

/* script */
__vue_exports__ = __webpack_require__(38)

/* template */
var __vue_template__ = __webpack_require__(68)
__vue_options__ = __vue_exports__ = __vue_exports__ || {}
if (
  typeof __vue_exports__.default === "object" ||
  typeof __vue_exports__.default === "function"
) {
if (Object.keys(__vue_exports__).some(function (key) { return key !== "default" && key !== "__esModule" })) {console.error("named exports are not supported in *.vue files.")}
__vue_options__ = __vue_exports__ = __vue_exports__.default
}
if (typeof __vue_options__ === "function") {
  __vue_options__ = __vue_options__.options
}
__vue_options__.__file = "/AliGitLab/qk-lightApp/src/components/article-list.vue"
__vue_options__.render = __vue_template__.render
__vue_options__.staticRenderFns = __vue_template__.staticRenderFns
__vue_options__._scopeId = "data-v-692adddb"
__vue_options__.style = __vue_options__.style || {}
__vue_styles__.forEach(function (module) {
  for (var name in module) {
    __vue_options__.style[name] = module[name]
  }
})
if (typeof __register_static_styles__ === "function") {
  __register_static_styles__(__vue_options__._scopeId, __vue_styles__)
}

module.exports = __vue_exports__


/***/ }),
/* 22 */
/***/ (function(module, exports, __webpack_require__) {

var __vue_exports__, __vue_options__
var __vue_styles__ = []

/* styles */
__vue_styles__.push(__webpack_require__(56)
)

/* script */
__vue_exports__ = __webpack_require__(39)

/* template */
var __vue_template__ = __webpack_require__(71)
__vue_options__ = __vue_exports__ = __vue_exports__ || {}
if (
  typeof __vue_exports__.default === "object" ||
  typeof __vue_exports__.default === "function"
) {
if (Object.keys(__vue_exports__).some(function (key) { return key !== "default" && key !== "__esModule" })) {console.error("named exports are not supported in *.vue files.")}
__vue_options__ = __vue_exports__ = __vue_exports__.default
}
if (typeof __vue_options__ === "function") {
  __vue_options__ = __vue_options__.options
}
__vue_options__.__file = "/AliGitLab/qk-lightApp/src/components/cards/big-image-card.vue"
__vue_options__.render = __vue_template__.render
__vue_options__.staticRenderFns = __vue_template__.staticRenderFns
__vue_options__._scopeId = "data-v-b39e0dbe"
__vue_options__.style = __vue_options__.style || {}
__vue_styles__.forEach(function (module) {
  for (var name in module) {
    __vue_options__.style[name] = module[name]
  }
})
if (typeof __register_static_styles__ === "function") {
  __register_static_styles__(__vue_options__._scopeId, __vue_styles__)
}

module.exports = __vue_exports__


/***/ }),
/* 23 */
/***/ (function(module, exports, __webpack_require__) {

var __vue_exports__, __vue_options__
var __vue_styles__ = []

/* script */
__vue_exports__ = __webpack_require__(40)
__vue_options__ = __vue_exports__ = __vue_exports__ || {}
if (
  typeof __vue_exports__.default === "object" ||
  typeof __vue_exports__.default === "function"
) {
if (Object.keys(__vue_exports__).some(function (key) { return key !== "default" && key !== "__esModule" })) {console.error("named exports are not supported in *.vue files.")}
__vue_options__ = __vue_exports__ = __vue_exports__.default
}
if (typeof __vue_options__ === "function") {
  __vue_options__ = __vue_options__.options
}
__vue_options__.__file = "/AliGitLab/qk-lightApp/src/components/cards/card.vue"
__vue_options__.style = __vue_options__.style || {}
__vue_styles__.forEach(function (module) {
  for (var name in module) {
    __vue_options__.style[name] = module[name]
  }
})
if (typeof __register_static_styles__ === "function") {
  __register_static_styles__(__vue_options__._scopeId, __vue_styles__)
}

module.exports = __vue_exports__


/***/ }),
/* 24 */
/***/ (function(module, exports, __webpack_require__) {

var __vue_exports__, __vue_options__
var __vue_styles__ = []

/* styles */
__vue_styles__.push(__webpack_require__(58)
)

/* script */
__vue_exports__ = __webpack_require__(41)

/* template */
var __vue_template__ = __webpack_require__(73)
__vue_options__ = __vue_exports__ = __vue_exports__ || {}
if (
  typeof __vue_exports__.default === "object" ||
  typeof __vue_exports__.default === "function"
) {
if (Object.keys(__vue_exports__).some(function (key) { return key !== "default" && key !== "__esModule" })) {console.error("named exports are not supported in *.vue files.")}
__vue_options__ = __vue_exports__ = __vue_exports__.default
}
if (typeof __vue_options__ === "function") {
  __vue_options__ = __vue_options__.options
}
__vue_options__.__file = "/AliGitLab/qk-lightApp/src/components/cards/single-image-card.vue"
__vue_options__.render = __vue_template__.render
__vue_options__.staticRenderFns = __vue_template__.staticRenderFns
__vue_options__._scopeId = "data-v-ddc5a636"
__vue_options__.style = __vue_options__.style || {}
__vue_styles__.forEach(function (module) {
  for (var name in module) {
    __vue_options__.style[name] = module[name]
  }
})
if (typeof __register_static_styles__ === "function") {
  __register_static_styles__(__vue_options__._scopeId, __vue_styles__)
}

module.exports = __vue_exports__


/***/ }),
/* 25 */
/***/ (function(module, exports, __webpack_require__) {

var __vue_exports__, __vue_options__
var __vue_styles__ = []

/* styles */
__vue_styles__.push(__webpack_require__(46)
)

/* script */
__vue_exports__ = __webpack_require__(42)

/* template */
var __vue_template__ = __webpack_require__(61)
__vue_options__ = __vue_exports__ = __vue_exports__ || {}
if (
  typeof __vue_exports__.default === "object" ||
  typeof __vue_exports__.default === "function"
) {
if (Object.keys(__vue_exports__).some(function (key) { return key !== "default" && key !== "__esModule" })) {console.error("named exports are not supported in *.vue files.")}
__vue_options__ = __vue_exports__ = __vue_exports__.default
}
if (typeof __vue_options__ === "function") {
  __vue_options__ = __vue_options__.options
}
__vue_options__.__file = "/AliGitLab/qk-lightApp/src/components/cards/text-card.vue"
__vue_options__.render = __vue_template__.render
__vue_options__.staticRenderFns = __vue_template__.staticRenderFns
__vue_options__._scopeId = "data-v-10f019a4"
__vue_options__.style = __vue_options__.style || {}
__vue_styles__.forEach(function (module) {
  for (var name in module) {
    __vue_options__.style[name] = module[name]
  }
})
if (typeof __register_static_styles__ === "function") {
  __register_static_styles__(__vue_options__._scopeId, __vue_styles__)
}

module.exports = __vue_exports__


/***/ }),
/* 26 */
/***/ (function(module, exports, __webpack_require__) {

var __vue_exports__, __vue_options__
var __vue_styles__ = []

/* styles */
__vue_styles__.push(__webpack_require__(51)
)

/* script */
__vue_exports__ = __webpack_require__(43)

/* template */
var __vue_template__ = __webpack_require__(66)
__vue_options__ = __vue_exports__ = __vue_exports__ || {}
if (
  typeof __vue_exports__.default === "object" ||
  typeof __vue_exports__.default === "function"
) {
if (Object.keys(__vue_exports__).some(function (key) { return key !== "default" && key !== "__esModule" })) {console.error("named exports are not supported in *.vue files.")}
__vue_options__ = __vue_exports__ = __vue_exports__.default
}
if (typeof __vue_options__ === "function") {
  __vue_options__ = __vue_options__.options
}
__vue_options__.__file = "/AliGitLab/qk-lightApp/src/components/cards/video-card.vue"
__vue_options__.render = __vue_template__.render
__vue_options__.staticRenderFns = __vue_template__.staticRenderFns
__vue_options__._scopeId = "data-v-3faafe94"
__vue_options__.style = __vue_options__.style || {}
__vue_styles__.forEach(function (module) {
  for (var name in module) {
    __vue_options__.style[name] = module[name]
  }
})
if (typeof __register_static_styles__ === "function") {
  __register_static_styles__(__vue_options__._scopeId, __vue_styles__)
}

module.exports = __vue_exports__


/***/ }),
/* 27 */
/***/ (function(module, exports, __webpack_require__) {

var __vue_exports__, __vue_options__
var __vue_styles__ = []

/* styles */
__vue_styles__.push(__webpack_require__(57)
)

/* script */
__vue_exports__ = __webpack_require__(44)

/* template */
var __vue_template__ = __webpack_require__(72)
__vue_options__ = __vue_exports__ = __vue_exports__ || {}
if (
  typeof __vue_exports__.default === "object" ||
  typeof __vue_exports__.default === "function"
) {
if (Object.keys(__vue_exports__).some(function (key) { return key !== "default" && key !== "__esModule" })) {console.error("named exports are not supported in *.vue files.")}
__vue_options__ = __vue_exports__ = __vue_exports__.default
}
if (typeof __vue_options__ === "function") {
  __vue_options__ = __vue_options__.options
}
__vue_options__.__file = "/AliGitLab/qk-lightApp/src/views/ArticleView.vue"
__vue_options__.render = __vue_template__.render
__vue_options__.staticRenderFns = __vue_template__.staticRenderFns
__vue_options__._scopeId = "data-v-ca2936b2"
__vue_options__.style = __vue_options__.style || {}
__vue_styles__.forEach(function (module) {
  for (var name in module) {
    __vue_options__.style[name] = module[name]
  }
})
if (typeof __register_static_styles__ === "function") {
  __register_static_styles__(__vue_options__._scopeId, __vue_styles__)
}

module.exports = __vue_exports__


/***/ }),
/* 28 */
/***/ (function(module, exports, __webpack_require__) {

var __vue_exports__, __vue_options__
var __vue_styles__ = []

/* styles */
__vue_styles__.push(__webpack_require__(54)
)

/* script */
__vue_exports__ = __webpack_require__(45)

/* template */
var __vue_template__ = __webpack_require__(69)
__vue_options__ = __vue_exports__ = __vue_exports__ || {}
if (
  typeof __vue_exports__.default === "object" ||
  typeof __vue_exports__.default === "function"
) {
if (Object.keys(__vue_exports__).some(function (key) { return key !== "default" && key !== "__esModule" })) {console.error("named exports are not supported in *.vue files.")}
__vue_options__ = __vue_exports__ = __vue_exports__.default
}
if (typeof __vue_options__ === "function") {
  __vue_options__ = __vue_options__.options
}
__vue_options__.__file = "/AliGitLab/qk-lightApp/src/views/ChannelView.vue"
__vue_options__.render = __vue_template__.render
__vue_options__.staticRenderFns = __vue_template__.staticRenderFns
__vue_options__._scopeId = "data-v-97309098"
__vue_options__.style = __vue_options__.style || {}
__vue_styles__.forEach(function (module) {
  for (var name in module) {
    __vue_options__.style[name] = module[name]
  }
})
if (typeof __register_static_styles__ === "function") {
  __register_static_styles__(__vue_options__._scopeId, __vue_styles__)
}

module.exports = __vue_exports__


/***/ }),
/* 29 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _router = __webpack_require__(7);

var _jssdk = __webpack_require__(0);

var _logUtil = __webpack_require__(2);

var _app = __webpack_require__(5);

var _weexRequire = __webpack_require__(3);

var _weexRequire2 = _interopRequireDefault(_weexRequire);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ucEvent = (0, _weexRequire2.default)('uc-event'); //
//
//
//
//
//
//
//
//
//
//
//
//

exports.default = {
  created: function created() {
    //设置Log开关
    if (this.isAndroidOs()) {
      (0, _logUtil.enableLog)(this.$getConfig().debug === 'true');
    } else {
      (0, _logUtil.enableLog)(this.$getConfig().debug === true);
    }

    var target = this.$getConfig().target;
    var categoryId = this.$getConfig().categoryId;
    var articleId = this.$getConfig().articleId;
    var themeInfo = JSON.parse(this.$getConfig().uc.theme);
    this.themeType = themeInfo.themeType;

    if (target === 'articlepage') {
      //打开正文页
      this.$router.push('article');
      this.log('--------open article');
    } else if (target === 'channelpage') {
      //打开频道页
      this.$router.push('channel');
      this.log('--------open channel');
    }

    var self = this;
    ucEvent.addEventListener('themeChange', function (theme) {
      var themeInfo = JSON.parse(theme);
      self.themeType = themeInfo.themeType;
    });
  },

  data: function data() {
    return {
      themeType: 0
    };
  }
};

/***/ }),
/* 30 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _textElement = __webpack_require__(19);

var _textElement2 = _interopRequireDefault(_textElement);

var _richtextElement = __webpack_require__(17);

var _richtextElement2 = _interopRequireDefault(_richtextElement);

var _imageElement = __webpack_require__(16);

var _imageElement2 = _interopRequireDefault(_imageElement);

var _videoElement = __webpack_require__(20);

var _videoElement2 = _interopRequireDefault(_videoElement);

var _headerElement = __webpack_require__(15);

var _headerElement2 = _interopRequireDefault(_headerElement);

var _footerElement = __webpack_require__(14);

var _footerElement2 = _interopRequireDefault(_footerElement);

var _tableElement = __webpack_require__(18);

var _tableElement2 = _interopRequireDefault(_tableElement);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
  components: {
    TextElement: _textElement2.default,
    ImageElement: _imageElement2.default,
    RichTextElement: _richtextElement2.default,
    HeaderElement: _headerElement2.default,
    FooterElement: _footerElement2.default,
    TableElement: _tableElement2.default
  },
  props: {
    initialElement: {
      type: Object
    },
    themeType: {}
  },
  data: function data() {
    return {
      element: this.initialElement
    };
  },
  methods: {
    appropriateComponent: function appropriateComponent() {
      var type = this.element.type;
      if (type == 0) {
        if (this.isAndroidOs()) {
          return this.isRichText(this.element) ? _richtextElement2.default : _textElement2.default;
        } else {
          return _textElement2.default;
        }
      }
      if (type == 1) {
        if (this.checkImageHeight(this.element.image.width, this.element.image.height)) {
          return 'div';
        }
        return _imageElement2.default;
      }
      if (type == 2) return _videoElement2.default;
      if (type == 4) return _tableElement2.default;
      if (type == -9) return _headerElement2.default;
      if (type == -8) return _footerElement2.default;
      return 'div';
    },
    isRichText: function isRichText(element) {
      return element.text.markups || element.linetype || element.blockquote;
    },
    checkImageHeight: function checkImageHeight(imgWidth, imgHeight) {
      var height = imgHeight / imgWidth * this.getScreenWidthPx();
      if (this.isAndroidOs() && height > this.getScreenHeightPx()) {
        return true;
      }
      return false;
    }
  },
  render: function render(createElement) {
    return createElement(this.appropriateComponent(), {
      props: {
        initialElement: this.element,
        themeType: this.themeType
      }
    });
  },
  created: function created() {}
}; //

/***/ }),
/* 31 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _jssdk = __webpack_require__(0);

exports.default = {
  props: {
    initialElement: {
      type: Object
    },
    themeType: {}
  },
  data: function data() {
    return {
      element: this.initialElement
    };
  },
  methods: {
    clickReport: function clickReport() {
      _jssdk.ucapi.lightapp.gotoReport(this.element, function (args) {}, function (args) {});
    },
    gotoOrigin: function gotoOrigin() {
      _jssdk.ucapi.lightapp.gotoOrigin({ "webUrl": this.element.webUrl }, function (args) {}, function (args) {});
    }
  },
  created: function created() {}
}; //
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//

/***/ }),
/* 32 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _formatUtil = __webpack_require__(1);

exports.default = {
  props: {
    initialElement: {
      type: Object
    },
    themeType: {}
  },
  data: function data() {
    return {
      element: this.initialElement,
      time: '',
      color: ''
    };
  },
  methods: {},
  created: function created() {
    this.time = (0, _formatUtil.formatTime)(this.element.text.time);
    this.color = this.$getConfig().iconColor;
  }
}; //
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//

/***/ }),
/* 33 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//

exports.default = {
  props: {
    initialElement: {
      type: Object
    },
    themeType: {}
  },
  data: function data() {
    return {
      element: this.initialElement,
      imageSource: '',
      imgWidth: 0,
      imgHeight: 0
    };
  },
  methods: {
    onloadImg: function onloadImg(e) {
      if (e.size && e.size.naturalWidth > 0 && e.size.naturalHeight > 0) {
        var width = e.size.naturalWidth;
        var height = e.size.naturalHeight;
        var deviceWidthInDp = this.ucConfig().env.windowWidth;
        var deviceWidthInPx = this.dpToPx(deviceWidthInDp);
        var maxWidth = deviceWidthInPx;
        if (width === 0) {
          width = maxWidth;
          height = maxWidth / 2;
        } else {
          height = maxWidth / width * height;
          width = maxWidth;
        }
        this.imgWidth = deviceWidthInDp;
        this.imgHeight = this.pxToDp(height);
      }
    }
  },
  created: function created() {
    this.imageSource = this.element.image.source;
    var width = this.element.image.width;
    var height = this.element.image.height;
    var deviceWidthInDp = this.ucConfig().env.windowWidth;
    var deviceWidthInPx = this.dpToPx(deviceWidthInDp);
    var maxWidth = deviceWidthInPx;
    if (width === 0) {
      width = maxWidth;
      height = maxWidth / 2;
    } else {
      height = maxWidth / width * height;
      width = maxWidth;
    }
    this.imgWidth = deviceWidthInDp;
    this.imgHeight = this.pxToDp(height);
  }
};

/***/ }),
/* 34 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//

var BLOCKQUOTE = "blockquote";
var P = "p";
var BIG = "big";
var SMALL = "small";
var H1 = "h1";
var H2 = "h2";
var H3 = "h3";
var STRONG = "strong";
var EM = "em";
var A = "a";
var SUPPROTLINETYPE = [BIG, SMALL, H1, H2, H3];
var SUPPROT_MARKUP_TAGS = [STRONG, EM, A];

exports.default = {
  props: {
    initialElement: {
      type: Object
    },
    themeType: {}
  },
  data: function data() {
    return {
      element: this.initialElement,
      prefixs: new Array(),
      suffixs: new Array(),
      value: ''
    };
  },
  methods: {
    genRichStyle: function genRichStyle() {
      //支持blockquote
      if (this.element.blockquote == 1) {
        this.addTag(BLOCKQUOTE);
      }

      //支持linetype
      if (this.isSupportLineType(this.element.linetype)) {
        this.addTag(this.element.linetype);
      }
      var allprefixs = this.prefixs.join('');
      var allsuffixs = this.suffixs.join('');
      var html = this.element.text.text;

      var replaceArray = new Array();
      if (this.element.text.markups) {
        for (var i = 0; i < this.element.text.markups.length; i++) {
          var markup = this.element.text.markups[i];
          if (this.isSupportMarkupTag(markup.tag)) {
            var source = html.substring(markup.start, markup.end);
            var prefix = markup.tag == A ? this.getATagPrefix(markup.source) : this.getPrefix(markup.tag);
            var replacement = prefix + source + this.getSuffix(markup.tag);
            replaceArray.push({ source: source, replacement: replacement });
          }
        }
      }
      for (var i = 0; i < replaceArray.length; i++) {
        var pair = replaceArray[i];
        html = html.replace(pair.source, pair.replacement);
      }
      html = allprefixs + html + allsuffixs;
      //替换换行符为<br/>
      html = html.replace(/\n/g, '<br/>');
      this.value = html;
    },
    getATagPrefix: function getATagPrefix(source) {
      return '<a href="' + source + '">';
    },
    isSupportMarkupTag: function isSupportMarkupTag(tag) {
      return SUPPROT_MARKUP_TAGS.indexOf(tag) != -1;
    },
    isSupportLineType: function isSupportLineType(linetype) {
      return SUPPROTLINETYPE.indexOf(linetype) != -1;
    },
    addTag: function addTag(tag) {
      this.prefixs.unshift(this.getPrefix(tag));
      this.suffixs.push(this.getSuffix(tag));
    },
    getPrefix: function getPrefix(tag) {
      if (tag === BLOCKQUOTE) {
        // 定制BLOCKQUOTE的样式
        var gap = this.dpToPx(12);
        if (this.isNightTheme()) {
          return '<' + tag + '  backgroundcolor="#1f2020" stripecolor="#555555" stripewidth="4" gap="' + gap + '"><font color="#555555">';
        } else {
          return '<' + tag + '  backgroundcolor="#ffffff" stripecolor="#666666" stripewidth="4" gap="' + gap + '"><font color="#666666">';
        }
      } else {
        return '<' + tag + '>';
      }
    },
    getSuffix: function getSuffix(tag) {
      if (tag === BLOCKQUOTE) {
        // 定制BLOCKQUOTE的样式
        return '</font></' + tag + '>';
      } else {
        return '</' + tag + '>';
      }
    }
  },
  created: function created() {
    this.genRichStyle();
  }
};

/***/ }),
/* 35 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//

var ROW_HEIGHT_IN_DP = 21;
exports.default = {
  props: {
    initialElement: {
      type: Object
    },
    themeType: {}
  },
  data: function data() {
    return {
      element: this.initialElement,
      rowCount: this.initialElement.table.rowCount,
      colCount: this.initialElement.table.colCount,
      items: this.initialElement.table.items,
      tableWidth: 0,
      tableHeight: 0
    };
  },
  methods: {},
  created: function created() {
    this.tableWidth = this.ucConfig().env.windowWidth - 30;
    this.tableHeight = ROW_HEIGHT_IN_DP * this.rowCount;
  }
};

/***/ }),
/* 36 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//

exports.default = {
  props: {
    initialElement: {
      type: Object
    },
    themeType: {}
  },
  data: function data() {
    return {
      element: this.initialElement
    };
  },
  methods: {},
  created: function created() {}
};

/***/ }),
/* 37 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//

exports.default = {
  props: {
    initialElement: {
      type: Object
    },
    themeType: {}
  },
  data: function data() {
    return {
      title: this.initialElement.media.title,
      videoUrl: this.initialElement.media.source,
      imageSource: this.initialElement.media.cover,
      imgWidth: 0,
      imgHeight: 0
    };
  },
  methods: {
    onloadVideo: function onloadVideo(e) {
      if (e.size && e.size.naturalWidth > 0 && e.size.naturalHeight > 0) {
        var width = e.size.naturalWidth;
        var height = e.size.naturalHeight;
        var deviceWidthInDp = this.ucConfig().env.windowWidth;
        var deviceWidthInPx = this.dpToPx(deviceWidthInDp);
        var maxWidth = deviceWidthInPx;
        if (width === 0) {
          width = maxWidth;
          height = maxWidth / 2;
        } else {
          height = maxWidth * height / width;
          width = maxWidth;
        }
        this.imgWidth = deviceWidthInDp;
        this.imgHeight = this.pxToDp(height);
      }
    }
  },
  created: function created() {
    this.imgWidth = this.ucConfig().env.windowWidth;
    this.imgHeight = this.imgWidth * 0.58;
  }
};

/***/ }),
/* 38 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _card = __webpack_require__(23);

var _card2 = _interopRequireDefault(_card);

var _fetch = __webpack_require__(6);

var _jssdk = __webpack_require__(0);

var _app = __webpack_require__(5);

var _cache = __webpack_require__(8);

var _statUtil = __webpack_require__(4);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//进入频道界面，立刻加载数据的频道个数，其他频道数据采取用时加载策略
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//

var MAX_CHANNEL_NUM_FOR_INSTANT_LOAD_DATA = 2;

var TIP_UPDATE_SUCCESS = '更新成功';
var TIP_UPDATE_FAILED = '网络问题，更新失败';
var TIP_UPDATE_ALEADY_UP_TO_DATE = '已经是最新';

exports.default = {
  components: {
    Card: _card2.default
  },
  props: {
    initialHost: {
      type: String
    },
    initialCategory: {
      type: Object
    },
    initialIndex: {
      type: Number
    },
    initialEventBus: {
      type: Object
    },
    themeType: {}
  },
  data: function data() {
    return {
      //文章数组
      articles: [],
      //文章列表数组，数组中的每个元素都是一次有效请求回来的文章列表数据
      dataArray: [],
      hasLoadData: false,
      refreshing: false,
      timeout: 10000
    };
  },
  computed: {
    getArticles: function getArticles() {
      return this.articles;
    }
  },
  methods: {
    /**
     * 获取文章列表接口的回调函数
     * @param {data} 返回结果
     * data.resultMsg的格式参照https://github.com/lianpian/partner-docs/blob/master/content/api_v2.md文档里面article.list接口的返回数据
     */
    onFirstTimeGetArticleList: function onFirstTimeGetArticleList(data) {
      if (data.resultCode === 'success') {
        if (this.validateArticleListData(data.resultMsg)) {
          this.updateArticleList(this.initialCategory.categoryId, data.resultMsg, false);
        } else {
          this.log("get first channel list failed 0x01");
        }
      } else {
        this.log("get first channel list failed 0x02");
      }
    },
    validateArticleListData: function validateArticleListData(data) {
      return data && data.ok && data.articles && data.articles.length > 0;
    },

    /**
     * 更新文章列表数据
     * @param {categoryId} 频道分类categoryId
     * @param {articleListData} 文章列表数据
     * @param {isAppend} 是否添加到当前文章列表的尾部
     */
    updateArticleList: function updateArticleList(categoryId, articleListData, isAppend) {
      var _this = this;

      if (this.validateArticleListData(articleListData)) {
        if (isAppend) {
          this.articles = this.articles.concat(articleListData.articles);
          var newTailIndex = this.dataArray.length;
          this.dataArray[newTailIndex] = articleListData;
          return true;
        } else if (this.isNewArticleListData(articleListData)) {
          if (this.isFirstChannelArticleList() && articleListData.articles.length > 0) {
            setTimeout(function () {
              _this.log("cacheArticleList");
              (0, _cache.cacheArticleList)(_this.initialCategory.categoryId, articleListData);
            }, 1000);
          }
          this.articles = articleListData.articles;
          this.dataArray = [];
          this.dataArray[0] = articleListData;
          return true;
        }
      } else {
        this.log("updateArticleList: articleListData is illegal");
        return false;
      }
    },

    /**
     * 是否新数据.判断逻辑是比较第一条数据标题是否一致，不一致就认为是新数据
     * @param {articleListData} 文章列表数据
     * 参照https://github.com/lianpian/partner-docs/blob/master/content/api_v2.md文档里面article.list接口的返回数据
     */
    isNewArticleListData: function isNewArticleListData(articleListData) {
      if (this.articles.length === 0) return true;
      return articleListData.articles.length > 0 && !this.isSameArticle(articleListData.articles[0], this.articles[0]);
    },

    /**
     * 是否同样的文章
     * @param {articleA} 文章A
     * @param {articleA} 文章B
     */
    isSameArticle: function isSameArticle(articleA, articleB) {
      return articleA && articleB && articleA.articleId === articleB.articleId;
    },

    /**
     * 尝试主动获取文章列表，只会执行一次
     */
    tryGetArticleList: function tryGetArticleList() {
      if (!this.hasLoadData) {
        this.hasLoadData = true;
        if (this.isFirstChannelArticleList()) {
          (0, _cache.getCachedArticleList)(this.initialCategory.categoryId, this.onGetCachedArticleListFailed, this.onGetCachedArticleListSuccess);
        } else {
          (0, _fetch.fetchArticleList)(this.$getConfig().userToken, this.initialCategory.categoryId, this.onFirstTimeGetArticleList, this.timeout);
        }
        this.log("load list data:" + this.initialIndex);
      }
    },
    onGetCachedArticleListFailed: function onGetCachedArticleListFailed() {
      this.log("onGetCachedArticleListFailed");
      (0, _fetch.fetchArticleList)(this.$getConfig().userToken, this.initialCategory.categoryId, this.onFirstTimeGetArticleList, this.timeout);
    },
    onGetCachedArticleListSuccess: function onGetCachedArticleListSuccess(data) {
      var _this2 = this;

      if (data) {
        try {
          var articleListData = JSON.parse(data);
          this.updateArticleList(this.initialCategory.categoryId, articleListData, false);
          this.log("onGetCachedArticleListSuccess");
        } catch (error) {
          this.log(error);
        }
      }
      setTimeout(function () {
        (0, _fetch.fetchArticleList)(_this2.$getConfig().userToken, _this2.initialCategory.categoryId, _this2.onFirstTimeGetArticleList, _this2.timeout);
      }, 500);
    },
    clickArticle: function clickArticle(articleId) {
      _jssdk.ucapi.lightapp.openArticlePage({ 'articleId': articleId, 'url': this.$getConfig().url }, function (args) {}, function (args) {});
      (0, _statUtil.stat)(_statUtil.EventID.clikArticle, {
        category_id: this.initialCategory.categoryId,
        host: this.initialHost,
        article_id: articleId
      });
    },

    /**
     * 触发下拉刷新操作
     */
    onPullToRefresh: function onPullToRefresh(event) {
      if (this.refreshing) return;
      this.refreshing = true;
      (0, _fetch.fetchArticleList)(this.$getConfig().userToken, this.initialCategory.categoryId, this.onGetArticleListByPullToRefresh, this.timeout);
      (0, _statUtil.stat)(_statUtil.EventID.pullToRefresh, {
        category_id: this.initialCategory.categoryId,
        host: this.initialHost
      });
    },

    /**
     * 下拉刷新数据回调
     * @param {data} 返回结果
     * data.resultMsg的格式参照https://github.com/lianpian/partner-docs/blob/master/content/api_v2.md文档里面article.list接口的返回数据
     */
    onGetArticleListByPullToRefresh: function onGetArticleListByPullToRefresh(data) {
      this.refreshing = false;
      if (data.resultCode === 'success') {
        if (this.validateArticleListData(data.resultMsg)) {
          var suc = this.updateArticleList(this.initialCategory.categoryId, data.resultMsg, false);
          if (suc) {
            this.dataArray[0] = data.resultMsg;
            this.log("get channel list by pulltorefresh success");
            this.toast(TIP_UPDATE_SUCCESS);
          } else {
            this.log("get channel list by pulltorefresh already up to date");
            this.toast(TIP_UPDATE_ALEADY_UP_TO_DATE);
          }
        } else {
          this.log("get channel list by pulltorefresh failed 0x1");
          this.toast(TIP_UPDATE_FAILED);
        }
      } else {
        this.toast(TIP_UPDATE_FAILED);
      }
    },

    /**
     * 滑动到底部触发加载更多
     */
    loadMoreArticles: function loadMoreArticles() {
      if (this.loadingmore) return;
      if (this.dataArray.length > 0) {
        var lastIndex = this.dataArray.length - 1;
        var data = this.dataArray[lastIndex];
        if (data && data.hasMore && data.nextUrl) {
          this.loadingmore = true;
          (0, _fetch.fetchNextUrl)(data.nextUrl, this.onGetMoreArticles, this.timeout);
          (0, _statUtil.stat)(_statUtil.EventID.loadMoreArticles, {
            category_id: this.initialCategory.categoryId,
            host: this.initialHost
          });
        }
      }
    },

    /**
     * 滑动到底部触发加载更多的数据回调
     * @param {data} 返回结果
     * data.resultMsg的格式参照https://github.com/lianpian/partner-docs/blob/master/content/api_v2.md文档里面article.list接口的返回数据
     */
    onGetMoreArticles: function onGetMoreArticles(data) {
      if (this.loadingmore) {
        this.loadingmore = false;
        if (data.resultCode === 'success') {
          if (this.validateArticleListData(data.resultMsg)) {
            this.updateArticleList(this.initialCategory.categoryId, data.resultMsg, true);
            this.log("get more articles success");
          } else {
            this.log("get more articles failed 0x1");
          }
        } else {
          this.log("get more articles failed 0x2");
        }
      }
    },
    isFirstChannelArticleList: function isFirstChannelArticleList() {
      return this.initialIndex === 0;
    }
  },
  created: function created() {
    var tryGetArticleListFunc = this.tryGetArticleList;
    var index = this.initialIndex;
    this.timeout = this.$getConfig().timeout;
    if (this.timeout == 0) {
      this.timeout = 10000;
    }
    this.initialEventBus.$on('loadArticleList', function (indexArray) {
      /**
       * 监听到频道加载数据的通知，判断自己是否需要主动加载文章列表
       * @param {indexArray} 需要加载数据的列表索引数组[左边频道索引，当前频道索引，右边频道索引]
       */
      var i = indexArray.indexOf(index);
      if (i != -1) {
        //索引是1说明是当前频道，立刻加载数据
        if (i === 1) {
          tryGetArticleListFunc();
        } else {
          //否则是当前频道的左右两边的频道，可以延迟一点再加载
          setTimeout(function () {
            tryGetArticleListFunc();
          }, 500);
        }
      }
    }
    //在当前频道列表被创建时，如果索引小于MAX_CHANNEL_NUM_FOR_INSTANT_LOAD_DATA，则开始加载文章列表
    );if (index < MAX_CHANNEL_NUM_FOR_INSTANT_LOAD_DATA) {
      //第一个频道优先立刻加载
      if (this.isFirstChannelArticleList()) {
        this.tryGetArticleList();
      } else {
        //其他频道延后加载
        setTimeout(function () {
          tryGetArticleListFunc();
        }, 500);
      }
    }
  }
};

/***/ }),
/* 39 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _formatUtil = __webpack_require__(1);

/**
 * 此值表示文字列表的左右间距，仅用于计算图片的最大宽度
 * 真正设置列表左右间距的地方在article-list.vue里面通过cell-item选择器指定
 * 2个地方的值必须保持同步
 */
var ARTICLE_LIST_PADDING_X = 16; //
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//

exports.default = {
  props: {
    initialElement: {
      type: Object
    },
    themeType: {},
    cellIndex: {
      type: Number
    }
  },
  data: function data() {
    return {
      element: this.initialElement,
      imageSource: '',
      imgWidth: 1,
      imgHeight: 1,
      title: '',
      content: '',
      time: ''
    };
  },
  methods: {
    onloadImg: function onloadImg(e) {
      if (e.size && e.size.naturalWidth > 0 && e.size.naturalHeight > 0) {
        var width = e.size.naturalWidth;
        var height = e.size.naturalHeight;
        var deviceWidthInDp = this.ucConfig().env.windowWidth;
        var deviceWidthInPx = this.dpToPx(deviceWidthInDp);
        var maxWidth = deviceWidthInPx - 2 * this.dpToPx(ARTICLE_LIST_PADDING_X);
        if (width === 0) {
          width = maxWidth;
          height = maxWidth / 2;
        } else {
          height = maxWidth / width * height;
          width = maxWidth;
        }
        this.imgWidth = this.pxToDp(width);
        this.imgHeight = this.pxToDp(height);
      }
    }
  },
  created: function created() {
    var width = 0;
    var height = 0;
    if (this.element.covers && this.element.covers[0]) {
      this.imageSource = this.element.covers[0].url;
      width = this.element.covers[0].width;
      height = this.element.covers[0].height;
    } else if (this.element.images && this.element.images[0]) {
      this.imageSource = this.element.images[0].url;
      width = this.element.images[0].width;
      height = this.element.images[0].height;
    }
    var deviceWidthInDp = this.$getConfig().env.deviceWidth;
    var deviceWidthInPx = this.dpToPx(deviceWidthInDp);
    var maxWidth = deviceWidthInPx - 2 * this.dpToPx(ARTICLE_LIST_PADDING_X);
    if (width === 0) {
      width = maxWidth;
      height = maxWidth / 2;
    } else {
      height = maxWidth / width * height;
      width = maxWidth;
    }

    this.imgWidth = this.pxToDp(width);
    this.imgHeight = this.pxToDp(height);

    this.title = this.element.title;
    this.content = this.element.snippet;
    this.time = (0, _formatUtil.formatTime)(this.element.crawlerTimestamp);
  }
};

/***/ }),
/* 40 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _bigImageCard = __webpack_require__(22);

var _bigImageCard2 = _interopRequireDefault(_bigImageCard);

var _singleImageCard = __webpack_require__(24);

var _singleImageCard2 = _interopRequireDefault(_singleImageCard);

var _textCard = __webpack_require__(25);

var _textCard2 = _interopRequireDefault(_textCard);

var _videoCard = __webpack_require__(26);

var _videoCard2 = _interopRequireDefault(_videoCard);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//

var TYPE_VIDEO = 'video'; // 视频
var TYPE_IMAGE = 'image'; // 单图
var TYPE_GALARY = 'galary'; // 多图
var TYPE_TEXT = 'text'; // 长文
var TYPE_NONE = 'none'; // 空

exports.default = {
  components: {
    BigImgCard: _bigImageCard2.default,
    SingleImgCard: _singleImageCard2.default,
    TextCard: _textCard2.default,
    VideoCard: _videoCard2.default
  },
  props: {
    initialElement: {
      type: Object
    },
    cellIndex: {
      type: Number
    },
    themeType: {}
  },
  data: function data() {
    return {
      element: this.initialElement
    };
  },
  methods: {
    getDataType: function getDataType() {
      var type = this.element.templateType;
      if (type === TYPE_TEXT) {
        // templateType是text
        if (this.element.covers && this.element.covers[0]) {
          // covers有数据
          var arrUrl = this.element.covers[0].url.split("/");
          var fileType = arrUrl[arrUrl.length - 1];
          if (fileType === 'gif') {
            // gif类型则认为是大图
            if (this.checkImageHeight(this.element.covers[0].width, this.element.covers[0].height)) {
              return TYPE_NONE;
            }
            return TYPE_IMAGE;
          } else {
            return TYPE_GALARY;
          }
        }
        //有title 归为bigImage样式
        else if (this.element.title.length > 0) {
            if (this.element.images && this.element.images[0] && this.checkImageHeight(this.element.images[0].width, this.element.images[0].height)) {
              return TYPE_NONE;
            }
            return TYPE_IMAGE;
          }
      }
      if (this.element.videos && this.element.videos[0] && this.element.videos[0].cover) {
        // 视频有数据，认为是视频
        return TYPE_VIDEO;
      }
      if (this.element.covers && this.element.covers[0]) {
        // 图片有数据，认为是图片
        if (this.checkImageHeight(this.element.covers[0].width, this.element.covers[0].height)) {
          return TYPE_NONE;
        }
        return TYPE_IMAGE;
      }
      if (this.element.images && this.element.images[0]) {
        if (this.checkImageHeight(this.element.images[0].width, this.element.images[0].height)) {
          return TYPE_NONE;
        }
        return TYPE_IMAGE;
      }
      return type;
    },
    checkImageHeight: function checkImageHeight(imgWidth, imgHeight) {
      var height = imgHeight / imgWidth * this.getScreenWidthPx();
      if (this.isAndroidOs() && height > 2 * this.getScreenHeightPx()) {
        return true;
      }
      return false;
    },
    appropriateComponent: function appropriateComponent() {
      var type = this.getDataType();
      if (type === TYPE_VIDEO) return _videoCard2.default;
      if (type === TYPE_IMAGE) return _bigImageCard2.default;
      if (type === TYPE_GALARY) return _singleImageCard2.default;
      if (type === TYPE_TEXT) return _textCard2.default;
      if (type === TYPE_NONE) return 'div';
      return _textCard2.default;
    }
  },
  render: function render(createElement) {
    return createElement(this.appropriateComponent(), {
      props: {
        initialElement: this.element,
        themeType: this.themeType,
        cellIndex: this.cellIndex
      }
    });
  },
  created: function created() {}
};

/***/ }),
/* 41 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _formatUtil = __webpack_require__(1);

exports.default = {
  props: {
    initialElement: {
      type: Object
    },
    themeType: {},
    cellIndex: {
      type: Number
    }
  },
  data: function data() {
    return {
      element: this.initialElement,
      maskOpacity: 0,
      imageSource: '',
      title: '',
      content: '',
      time: ''
    };
  },
  methods: {
    onloadImg: function onloadImg() {}
  },
  created: function created() {
    if (this.element.covers && this.element.covers[0]) {
      this.imageSource = this.element.covers[0].url;
    } else if (this.element.images && this.element.images[0]) {
      this.imageSource = this.element.images[0].url;
    }

    this.title = this.element.title;
    this.content = this.element.snippet;
    this.time = (0, _formatUtil.formatTime)(this.element.crawlerTimestamp);
  }
}; //
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//

/***/ }),
/* 42 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _formatUtil = __webpack_require__(1);

exports.default = {
  props: {
    initialElement: {
      type: Object
    },
    themeType: {},
    cellIndex: {
      type: Number
    }
  },
  data: function data() {
    return {
      element: this.initialElement,
      title: '',
      content: '',
      time: ''
    };
  },
  methods: {},
  created: function created() {
    this.title = this.element.title;
    this.content = this.element.snippet;
    this.time = (0, _formatUtil.formatTime)(this.element.crawlerTimestamp);
  }
}; //
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//

/***/ }),
/* 43 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _formatUtil = __webpack_require__(1);

var _weexRequire = __webpack_require__(3);

var _weexRequire2 = _interopRequireDefault(_weexRequire);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
* 此值表示文字列表的左右间距，仅用于计算图片的最大宽度
* 真正设置列表左右间距的地方在article-list.vue里面通过cell-item选择器指定
* 2个地方的值必须保持同步
*/
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//

var ARTICLE_LIST_PADDING_X = 13;

exports.default = {
  props: {
    initialElement: {
      type: Object
    },
    themeType: {},
    cellIndex: {
      type: Number
    }
  },
  data: function data() {
    return {
      element: this.initialElement,
      imageSource: '',
      videoUrl: '',
      imgWidth: 0,
      imgHeight: 0,
      title: '',
      content: '',
      time: '',
      videoDuration: ''
    };
  },
  methods: {
    showmsg: function showmsg(text) {
      var modal = (0, _weexRequire2.default)('modal');
      modal.toast({
        message: text,
        duration: 3
      });
    },
    changeToDuration: function changeToDuration(duration) {
      duration = parseInt(duration);
      var min = parseInt(duration / 60);
      min = min < 10 ? '0' + min : min;
      var sec = duration % 60;
      sec = sec < 10 ? '0' + sec : sec;
      return min + ':' + sec;
    },
    onloadVideo: function onloadVideo(e) {
      if (e.size && e.size.naturalWidth > 0 && e.size.naturalHeight > 0) {
        var width = e.size.naturalWidth;
        var height = e.size.naturalHeight;
        var deviceWidthInDp = this.ucConfig().env.windowWidth;
        var deviceWidthInPx = this.dpToPx(deviceWidthInDp);
        var maxWidth = deviceWidthInPx;
        if (width === 0) {
          width = maxWidth;
          height = maxWidth / 2;
        } else {
          height = maxWidth * height / width;
          width = maxWidth;
        }
        this.imgWidth = this.pxToDp(width);
        this.imgHeight = this.pxToDp(height);
      }
    }
  },
  created: function created() {
    if (this.element.videos && this.element.videos[0]) {
      if (this.element.videos[0].cover) {
        this.imageSource = this.element.videos[0].cover.url;
      }
      var width = this.element.videos[0].width;
      var height = this.element.videos[0].height;

      var deviceWidthInDp = this.ucConfig().env.windowWidth;
      var deviceWidthInPx = this.dpToPx(deviceWidthInDp);
      var maxWidth = deviceWidthInPx;
      if (width === 0) {
        width = maxWidth;
        height = maxWidth / 2;
      } else {
        height = maxWidth * height / width;
        width = maxWidth;
      }
      this.imgWidth = this.pxToDp(width);
      this.imgHeight = this.pxToDp(height);
      if (this.element.videos[0].url) {
        this.videoUrl = this.element.videos[0].url;
      }
      if (this.element.videos[0].duration) {
        this.log("sdhaskdjlasd");
        this.log(this.element.videos[0].duration);
        this.videoDuration = this.changeToDuration(this.element.videos[0].duration);
      }
    }
    this.title = this.element.title;
    this.content = this.element.snippet;
    this.time = (0, _formatUtil.formatTime)(this.element.crawlerTimestamp);
  }
};

/***/ }),
/* 44 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _articleElement = __webpack_require__(13);

var _articleElement2 = _interopRequireDefault(_articleElement);

var _fetch = __webpack_require__(6);

var _statUtil = __webpack_require__(4);

var _jssdk = __webpack_require__(0);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//

var INIT_VISIBLE_ITEM_COUNT = 10;

exports.default = {
  components: {
    articleElement: _articleElement2.default
  },
  props: {
    themeType: {}
  },
  data: function data() {
    return {
      articleId: '',
      token: '',
      index: 0,
      displayElements: [],
      allElements: [],
      loading: true,
      isError: false,
      hasAutoReload: false,
      screenWidth: 0,
      listHeight: 0
    };
  },

  methods: {
    fetchMore: function fetchMore(count) {
      var length = this.allElements.length;
      var start = this.index;
      var end = start + count < this.allElements.length ? start + count : this.allElements.length;
      this.displayElements = this.allElements.slice(start, end);
      this.index = end;
    },

    /**
     * 获取文章数据
     */
    tryGetArticle: function tryGetArticle() {
      this.log('tryGetArticle' + this.articleId);
      (0, _fetch.fetchArticle)(this.token, this.articleId, this.onGetArticle, this.timeout);
    },

    /**
     * 获取文章数据的回调函数
     * @param {data} 具体定义参照../qingmang/fetch.js的fetch函数
     */
    onGetArticle: function onGetArticle(data) {
      var _this = this;

      this.log('--------onGetArticle');
      this.log(data);
      if (data.resultCode === 'success') {
        if (data.resultMsg.ok && data.resultMsg && data.resultMsg.article && data.resultMsg.article.content) {
          _jssdk.ucapi.lightapp.onGetArticleData(data.resultMsg.article, function (args) {}, function (args) {}
          //隐藏加载中提示
          );this.hideLoadingText
          //隐藏加载错误提示
          ();this.hideErrorText();

          this.log('--------onGetArticle success');

          try {
            var content = JSON.parse(data.resultMsg.article.content);
            this.allElements = content;

            this.addHeader(data.resultMsg.article.title, data.resultMsg.article.author, data.resultMsg.article.crawlerTimestamp);

            var categoryName = '';
            if (data.resultMsg.article.categories[0].name) {
              categoryName = data.resultMsg.article.categories[0].name;
            }
            this.addFooter(data.resultMsg.article.articleId, data.resultMsg.article.author, data.resultMsg.article.title, categoryName, data.resultMsg.article.providerName, data.resultMsg.article.webUrl

            //先加载部分元素，避免一次加载过多元素导致首帧显示慢
            );this.fetchMore(INIT_VISIBLE_ITEM_COUNT

            //延迟300毫秒再加载全部元素
            );setTimeout(function () {
              _this.displayElements = _this.allElements;
            }, 300);
          } catch (error) {
            this.log(error);
            this.showErrorText();
          }
        } else {
          if (!this.autoReloadIfNeed()) {
            this.hideLoadingText();
            this.showErrorText();
          }
        }
      } else {
        if (!this.autoReloadIfNeed()) {
          this.hideLoadingText();
          this.showErrorText();
        }
      }
    },
    addHeader: function addHeader(title, author, time) {
      // 将标题，作者等元素封装成一个元素，插在content所有元素且前面，并且约定好id是0000，type是-9
      var header = {
        id: '0000',
        type: '-9',
        text: {
          title: '',
          author: '',
          time: ''
        }
      };
      header.text.title = title;
      header.text.author = author;
      header.text.time = time;
      this.allElements.unshift(header);
    },
    addFooter: function addFooter(articleId, author, title, categoryName, providerName, webUrl) {
      // 版权举报,约定好id是9999，type是-8
      var footer = {
        id: '9999',
        type: '-8',
        articleId: articleId,
        author: author,
        title: title,
        categoryName: categoryName,
        providerName: providerName,
        webUrl: webUrl,
        text: {
          content: '版权举报'
        }
      };
      this.allElements.push(footer);
    },
    autoReloadIfNeed: function autoReloadIfNeed() {
      var _this2 = this;

      if (!this.hasAutoReload) {
        this.hasAutoReload = true;
        setTimeout(function () {
          _this2.tryGetArticle();
        }, 300);
        return true;
      } else {
        return false;
      }
    },
    showErrorText: function showErrorText() {
      this.isError = true;
      (0, _statUtil.stat)(_statUtil.EventID.showArticleErrorTip, { article_id: this.articleId });
    },
    hideErrorText: function hideErrorText() {
      this.isError = false;
    },
    onClickErrorText: function onClickErrorText() {
      var _this3 = this;

      this.hideErrorText();
      this.showLoadingText();
      setTimeout(function () {
        _this3.tryGetArticle();
      }, 500);
      (0, _statUtil.stat)(_statUtil.EventID.clickToReloadArtcle, { article_id: this.articleId });
    },
    showLoadingText: function showLoadingText() {
      this.loading = true;
    },
    hideLoadingText: function hideLoadingText() {
      this.loading = false;
    }
  },
  computed: {
    getDisplayElements: function getDisplayElements() {
      return this.displayElements;
    }
  },
  created: function created() {
    this.articleId = this.$getConfig().articleId;
    this.token = this.$getConfig().userToken;
    this.screenWidth = this.ucConfig().env.windowWidth;
    this.listHeight = this.ucConfig().env.windowHeight - this.ucConfig().env.statusBarHeight;
    if (this.timeout == 0) {
      this.timeout = 10000;
    }
    this.tryGetArticle();
    (0, _statUtil.stat)(_statUtil.EventID.openArticleView, { article_id: this.articleId });
    this.log('--------article created');
  }
};

/***/ }),
/* 45 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _articleList = __webpack_require__(21);

var _articleList2 = _interopRequireDefault(_articleList);

var _jssdk = __webpack_require__(0);

var _cache = __webpack_require__(8);

var _fetch = __webpack_require__(6);

var _statUtil = __webpack_require__(4);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//

var HAS_ALREADY_ADD_TO_NAVI = "已经添加到导航";
var ADD_TO_NAVI_FAILED = "导航已满";
exports.default = {
  components: {
    ArticleList: _articleList2.default
  },
  props: {
    themeType: {}
  },
  data: function data() {
    return {
      eventBus: new Vue(),
      token: '',
      viewPagerSelectIndex: 0,
      /**
       *tabSelectIndex和selectIndex都是代表当前索引，为了避免在tablayout和uc-viewpager联动时出现死循环的情况
       *tabSelectIndex用于绑定tablayout,selectIndex用于绑定uc-viewpager
       */
      tabSelectIndex: 0, //
      categoryId: 0,
      showTabLayout: !this.isAndroidOs(),
      title: '',
      subCategories: [],
      subCategoriesOnlyName: [],
      isFirstTimeGetCategories: true,
      showAddButton: true,
      channelListData: new Array(),
      timeout: 10000,
      iconUrl: 'localResImage://' + this.$getConfig().iconName
    };
  },
  computed: {
    getCurrentIndex: function getCurrentIndex() {
      return this.viewPagerSelectIndex;
    },
    getSubCategories: function getSubCategories() {
      return this.subCategories;
    },
    getChannelList: function getChannelList() {
      return this.channelListData;
    }
  },
  methods: {
    /**
     * 频道列表切换回调函数
     * @param {param} param.position为当前频道索引
     */
    onPageSelected: function onPageSelected(param) {
      if (this.subCategoriesOnlyName.length > param.position) {
        this.tabSelectIndex = param.position;
        this.loadChannelData(this.tabSelectIndex);
        this.log('========onPageSelected' + this.tabSelectIndex);
      }
    },

    /**
     * 加载指定频道数据，同时预加载频道左右两边频道的数据
     * @param {index} 当前频道索引
     */
    loadChannelData: function loadChannelData(index) {
      //[左边频道索引，当前频道索引，右边频道索引]
      var indexArray = new Array(index - 1, index, index + 1);
      this.eventBus.$emit('loadArticleList', indexArray);
    },
    onPageScroll: function onPageScroll(param) {},

    /**
     * 点击Tab栏回调函数
     * @param {param} param.index 当前索引
     */
    onTabSelect: function onTabSelect(param) {
      this.viewPagerSelectIndex = param.index;
      this.loadChannelData(this.viewPagerSelectIndex);
      this.log('========onTabSelect' + this.viewPagerSelectIndex);
    },

    /**
     * 获取频道栏信息
     */
    tryGetCategoryInfo: function tryGetCategoryInfo() {
      (0, _cache.getCachedCategoryInfo)(this.categoryId, this.onGetCacheFailed, this.onGetCacheSuccess);
    },

    /**
     * 获取缓存数据成功
     */
    onGetCacheSuccess: function onGetCacheSuccess(arg) {
      this.log('onGetCacheSuccess');
      if (arg) {
        try {
          this.updateCategoryInfo(JSON.parse(arg));
        } catch (error) {
          this.log(error);
        }
      }
      //向从服务器请求最新数据，供下次使用
      (0, _fetch.fetchCategoryInfo)(this.token, this.categoryId, this.onGetCategoryInfoFromServer, this.timeout);
    },

    /**
     * 获取缓存数据失败
     */
    onGetCacheFailed: function onGetCacheFailed() {
      this.log('onGetCacheFailed'
      //向从服务器请求数据
      );(0, _fetch.fetchCategoryInfo)(this.token, this.categoryId, this.onGetCategoryInfoFromServer, this.timeout);
    },

    /**
     * 更新频道栏
     */
    updateTabData: function updateTabData() {
      var array = new Array();
      if (this.subCategories) {
        for (var i = 0; i < this.subCategories.length; i++) {
          array[i] = this.subCategories[i].name;
        }
      }
      this.subCategoriesOnlyName = array;
    },
    updateCategoryInfo: function updateCategoryInfo(category) {
      this.subCategories = category.subCategories;
      if (this.subCategories.length === 1) {
        this.showTabLayout = false;
      } else {
        this.updateTabData();
        this.showTabLayout = true;
      }
    },

    /**
     * 获取频道栏信息的回调函数
     * @param {data} 具体定义参照../service/fetch.js的fetch函数
     */
    onGetCategoryInfoFromServer: function onGetCategoryInfoFromServer(data) {
      if (data.resultCode === 'success') {
        if (data.resultMsg.ok) {
          if (this.subCategories.length === 0) {
            this.updateCategoryInfo(data.resultMsg.category);
          }
          (0, _cache.cacheCategoryInfo)(data.resultMsg.category);
        }
      } else {}
    },

    /**
     * 点击标题栏右边的添加到导航按钮
     */
    onClickAddButton: function onClickAddButton() {
      this.showAddButton = false;
      var toastMeathod = this.toast;
      _jssdk.ucapi.lightapp.addToNavigation(this.$getConfig().url, this.$getConfig().title, this.$getConfig().categoryId, function (args) {
        toastMeathod(ADD_TO_NAVI_FAILED);
      }, function (args) {
        toastMeathod(HAS_ALREADY_ADD_TO_NAVI);
      });
      (0, _statUtil.stat)(_statUtil.EventID.clickAddButton, { title: this.title });
    },
    onClickBackButton: function onClickBackButton() {
      _jssdk.ucapi.lightapp.exit();
    }
  },
  created: function created() {
    this.categoryId = this.$getConfig().categoryId;
    this.title = this.$getConfig().title;
    this.token = this.$getConfig().userToken;
    this.timeout = this.$getConfig().timeout;
    if (this.timeout == 0) {
      this.timeout = 10000;
    }
    this.showAddButton = this.$getConfig().isInNavigation === "false";
    this.tryGetCategoryInfo();
    (0, _statUtil.stat)(_statUtil.EventID.openChannelView, { title: this.title });
  }
};

/***/ }),
/* 46 */
/***/ (function(module, exports) {

module.exports = {
  "cell-item-container": {
    "marginLeft": 16,
    "marginRight": 16
  },
  "cell-item": {
    "justifyContent": "space-between",
    "position": "relative"
  },
  "content": {
    "color": "#222222",
    "fontSize": 13,
    "textAlign": "left",
    "lineHeight": 21
  },
  "content_nig": {
    "color": "#888888"
  },
  "time": {
    "color": "#999999",
    "fontSize": 11,
    "textAlign": "left",
    "lineHeight": 17,
    "marginTop": 16
  },
  "time_nig": {
    "color": "#333333"
  },
  "divider": {
    "height": 1,
    "backgroundColor": "#dddddd",
    "marginTop": 13
  },
  "divider_nig": {
    "backgroundColor": "#3f3f3f"
  }
}

/***/ }),
/* 47 */
/***/ (function(module, exports) {

module.exports = {
  "cell-item": {
    "alignItems": "center",
    "justifyContent": "center",
    "flexDirection": "row",
    "paddingTop": 26,
    "paddingBottom": 10,
    "paddingLeft": 0,
    "paddingRight": 0
  },
  "text": {
    "fontSize": 9,
    "color": "#666666",
    "lineHeight": 11,
    "padding": 7
  },
  "text_nig": {
    "color": "#555555"
  }
}

/***/ }),
/* 48 */
/***/ (function(module, exports) {

module.exports = {
  "cell-item": {
    "position": "relative",
    "alignItems": "center",
    "textAlign": "center"
  },
  "table": {
    "padding": 7
  }
}

/***/ }),
/* 49 */
/***/ (function(module, exports) {

module.exports = {
  "cell-item": {
    "position": "relative",
    "paddingTop": 7,
    "paddingBottom": 7,
    "paddingLeft": 26,
    "paddingRight": 26
  },
  "text": {
    "fontSize": 14,
    "color": "#222222",
    "lineHeight": 28
  },
  "text_nig": {
    "color": "#888888"
  }
}

/***/ }),
/* 50 */
/***/ (function(module, exports) {

module.exports = {
  "wrapper_nig": {
    "backgroundColor": "#1f2020"
  },
  "wrapper": {
    "backgroundColor": "#ffffff"
  }
}

/***/ }),
/* 51 */
/***/ (function(module, exports) {

module.exports = {
  "cell-item-container": {
    "marginBottom": 22
  },
  "cell-item": {
    "position": "relative"
  },
  "title": {
    "color": "#222222",
    "fontSize": 16,
    "fontWeight": "bold",
    "marginLeft": 16,
    "marginRight": 16,
    "marginTop": 10,
    "textAlign": "left",
    "lineHeight": 20
  },
  "title_nig": {
    "color": "#888888"
  },
  "content": {
    "color": "#999999",
    "fontSize": 11,
    "textAlign": "left",
    "lineHeight": 17,
    "marginTop": 12,
    "marginLeft": 16,
    "marginRight": 16
  },
  "content_nig": {
    "color": "#333333"
  },
  "time": {
    "color": "#999999",
    "fontSize": 11,
    "textAlign": "left",
    "lineHeight": 12,
    "marginTop": 12,
    "marginLeft": 16,
    "marginRight": 16
  },
  "time_nig": {
    "color": "#333333"
  }
}

/***/ }),
/* 52 */
/***/ (function(module, exports) {

module.exports = {
  "cell-item": {
    "position": "relative",
    "paddingTop": 12,
    "paddingBottom": 12,
    "paddingLeft": 19,
    "paddingRight": 19
  },
  "text": {
    "fontSize": 14,
    "color": "#222222",
    "lineHeight": 24
  },
  "text_nig": {
    "color": "#888888"
  }
}

/***/ }),
/* 53 */
/***/ (function(module, exports) {

module.exports = {
  "refresh": {
    "alignItems": "center",
    "height": 45
  },
  "loading_icon": {
    "margin": 9,
    "width": 27,
    "height": 27
  }
}

/***/ }),
/* 54 */
/***/ (function(module, exports) {

module.exports = {
  "addButtonContainer": {
    "flexDirection": "row",
    "position": "absolute",
    "height": 28,
    "top": 12,
    "left": 0,
    "right": 0,
    "bottom": 0,
    "alignItems": "center"
  },
  "topbar": {
    "height": 36
  },
  "titlecontainer": {
    "flexDirection": "row",
    "justifyContent": "center",
    "alignItems": "center",
    "position": "absolute",
    "top": 15,
    "left": 0,
    "right": 0,
    "bottom": 0
  },
  "topicon": {
    "height": 20,
    "width": 20,
    "marginRight": 8
  },
  "title": {
    "color": "#222222",
    "fontSize": 16,
    "fontWeight": "bold"
  },
  "title_nig": {
    "color": "#888888"
  },
  "listitem": {
    "height": 66
  },
  "viewpager": {
    "flex": 1
  },
  "tablayout": {
    "height": 48,
    "marginTop": 8
  },
  "placeholder": {
    "height": 10
  },
  "wrapper": {
    "flex": 1,
    "flexDirection": "column"
  },
  "wrapper_nig": {
    "backgroundColor": "#1f2020"
  }
}

/***/ }),
/* 55 */
/***/ (function(module, exports) {

module.exports = {
  "cell-item": {
    "alignItems": "center",
    "position": "relative",
    "paddingTop": 7,
    "paddingBottom": 7
  }
}

/***/ }),
/* 56 */
/***/ (function(module, exports) {

module.exports = {
  "cell-item-container": {
    "marginLeft": 16,
    "marginRight": 16,
    "marginBottom": 22
  },
  "image": {
    "borderRadius": 10,
    "backgroundColor": "#f5f5f5"
  },
  "image_nig": {
    "backgroundColor": "#7a7a7a"
  },
  "title": {
    "color": "#222222",
    "fontSize": 16,
    "fontWeight": "bold",
    "textAlign": "left",
    "lineHeight": 22,
    "marginTop": 12
  },
  "title_nig": {
    "color": "#888888"
  },
  "content": {
    "color": "#999999",
    "fontSize": 11,
    "textAlign": "left",
    "lineHeight": 15,
    "marginTop": 12
  },
  "content_nig": {
    "color": "#333333"
  },
  "time": {
    "color": "#999999",
    "fontSize": 11,
    "textAlign": "left",
    "lineHeight": 17,
    "marginTop": 12
  },
  "time_nig": {
    "color": "#333333"
  },
  "divider": {
    "height": 1,
    "backgroundColor": "#dddddd",
    "marginTop": 16
  },
  "divider_nig": {
    "backgroundColor": "#3f3f3f"
  },
  "mask": {
    "borderRadius": 10,
    "backgroundColor": "#000000",
    "opacity": 0,
    "position": "absolute",
    "top": 0
  },
  "mask_nig": {
    "opacity": 0.5
  }
}

/***/ }),
/* 57 */
/***/ (function(module, exports) {

module.exports = {
  "wrapper": {
    "alignItems": "center"
  },
  "wrapper_nig": {
    "backgroundColor": "#1f2020"
  },
  "msg": {
    "top": 0
  },
  "tip": {
    "marginTop": 166,
    "height": 33,
    "alignItems": "center",
    "justifyContent": "center"
  },
  "tip-text": {
    "textAlign": "center",
    "fontSize": 12,
    "color": "#000000"
  },
  "tip-text_nig": {
    "color": "#888888"
  }
}

/***/ }),
/* 58 */
/***/ (function(module, exports) {

module.exports = {
  "cell-item-container": {
    "marginLeft": 16,
    "marginRight": 16
  },
  "cell-item": {
    "flexDirection": "row",
    "justifyContent": "space-between",
    "position": "relative"
  },
  "item-left": {
    "position": "relative",
    "paddingRight": 20,
    "flex": 1
  },
  "title": {
    "lines": 2,
    "color": "#222222",
    "fontSize": 16,
    "fontWeight": "bold",
    "textAlign": "left",
    "lineHeight": 22,
    "textOverflow": "ellipsis"
  },
  "title_nig": {
    "color": "#888888"
  },
  "content": {
    "lines": 3,
    "color": "#999999",
    "fontSize": 11,
    "textAlign": "left",
    "lineHeight": 17,
    "marginTop": 12,
    "textOverflow": "ellipsis"
  },
  "content_nig": {
    "color": "#333333"
  },
  "time": {
    "color": "#999999",
    "fontSize": 9,
    "marginTop": 14,
    "textAlign": "left",
    "lineHeight": 17
  },
  "time_nig": {
    "color": "#333333"
  },
  "logo": {
    "width": 133,
    "height": 100,
    "borderRadius": 3,
    "backgroundColor": "#f5f5f5"
  },
  "logo_nig": {
    "backgroundColor": "#7a7a7a"
  },
  "divider": {
    "height": 1,
    "marginTop": 16,
    "backgroundColor": "#dddddd"
  },
  "divider_nig": {
    "backgroundColor": "#3f3f3f"
  },
  "mask": {
    "borderRadius": 3,
    "backgroundColor": "#000000",
    "opacity": 0,
    "position": "absolute",
    "top": 0,
    "width": 133,
    "height": 100
  },
  "mask_nig": {
    "opacity": 0.5
  }
}

/***/ }),
/* 59 */
/***/ (function(module, exports) {

module.exports = {
  "cell-item": {
    "justifyContent": "center"
  },
  "title": {
    "color": "#222222",
    "fontSize": 18,
    "lineHeight": 26,
    "fontWeight": "bold",
    "textAlign": "left",
    "marginTop": 30,
    "marginLeft": 30,
    "marginRight": 30
  },
  "title_nig": {
    "color": "#888888"
  },
  "title-divider": {
    "height": 2,
    "width": 18,
    "marginLeft": 30,
    "marginTop": 8,
    "borderRadius": 5
  },
  "author-container": {
    "marginLeft": 30,
    "flexDirection": "row",
    "marginTop": 12,
    "marginBottom": 12
  },
  "author": {
    "color": "#999999",
    "fontSize": 9,
    "lineHeight": 9,
    "marginRight": 5
  },
  "author_nig": {
    "color": "#333333"
  },
  "time": {
    "color": "#999999",
    "fontSize": 9,
    "lineHeight": 10
  },
  "time_nig": {
    "color": "#333333"
  }
}

/***/ }),
/* 60 */
/***/ (function(module, exports) {

module.exports = {
  "cell-item": {
    "alignItems": "center",
    "position": "relative",
    "paddingTop": 12,
    "paddingBottom": 12
  },
  "mask": {
    "backgroundColor": "#000000",
    "opacity": 0,
    "position": "absolute",
    "top": 12
  },
  "mask_nig": {
    "opacity": 0.5
  },
  "logo": {
    "backgroundColor": "#f5f5f5"
  },
  "logo_nig": {
    "backgroundColor": "#7a7a7a"
  }
}

/***/ }),
/* 61 */
/***/ (function(module, exports) {

module.exports={render:function (){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;
  return _c('div', {
    staticClass: ["cell-item-container"],
    style: {
      marginTop: (0 == _vm.cellIndex) ? 6 : 16
    }
  }, [_c('div', {
    staticClass: ["cell-item"]
  }, [(_vm.content) ? _c('text', {
    class: _vm.themeClass('content')
  }, [_vm._v(_vm._s(_vm.content))]) : _vm._e(), (_vm.time) ? _c('text', {
    class: _vm.themeClass('time')
  }, [_vm._v(_vm._s(_vm.time))]) : _vm._e()]), _c('dividingline', {
    class: _vm.themeClass('divider')
  })], 1)
},staticRenderFns: []}
module.exports.render._withStripped = true

/***/ }),
/* 62 */
/***/ (function(module, exports) {

module.exports={render:function (){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;
  return _c('div', {
    staticClass: ["cell-item"]
  }, [_c('text', {
    class: _vm.themeClass('text'),
    on: {
      "click": function($event) {
        _vm.gotoOrigin()
      }
    }
  }, [_vm._v("查看原文")]), _c('text', {
    class: _vm.themeClass('text')
  }, [_vm._v("|")]), _c('text', {
    class: _vm.themeClass('text'),
    on: {
      "click": function($event) {
        _vm.clickReport()
      }
    }
  }, [_vm._v(_vm._s(_vm.element.text.content))])])
},staticRenderFns: []}
module.exports.render._withStripped = true

/***/ }),
/* 63 */
/***/ (function(module, exports) {

module.exports={render:function (){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;
  return _c('div', {
    staticClass: ["cell-item"]
  }, [_c('text-table', {
    staticClass: ["table"],
    style: {
      width: _vm.tableWidth + 'px',
      height: _vm.tableHeight + 'px'
    },
    attrs: {
      "rowCount": _vm.rowCount,
      "colCount": _vm.colCount,
      "items": _vm.items
    }
  })], 1)
},staticRenderFns: []}
module.exports.render._withStripped = true

/***/ }),
/* 64 */
/***/ (function(module, exports) {

module.exports={render:function (){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;
  return _c('div', {
    staticClass: ["cell-item"]
  }, [_c('uc-rich-text', {
    class: _vm.themeClass('text'),
    attrs: {
      "value": _vm.value
    }
  })], 1)
},staticRenderFns: []}
module.exports.render._withStripped = true

/***/ }),
/* 65 */
/***/ (function(module, exports) {

module.exports={render:function (){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;
  return _c('div', {
    class: _vm.themeClass('wrapper')
  }, [_c('router-view', {
    attrs: {
      "themeType": _vm.themeType
    }
  })], 1)
},staticRenderFns: []}
module.exports.render._withStripped = true

/***/ }),
/* 66 */
/***/ (function(module, exports) {

module.exports={render:function (){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;
  return _c('div', {
    staticClass: ["cell-item-container"],
    style: {
      marginTop: (0 == _vm.cellIndex) ? 10 : 16
    }
  }, [_c('div', {
    staticClass: ["cell-item"]
  }, [_c('quark-video', {
    staticClass: ["video"],
    style: {
      width: _vm.imgWidth + 'px',
      height: _vm.imgHeight + 'px'
    },
    attrs: {
      "posterUrl": _vm.imageSource,
      "videoUrl": _vm.videoUrl,
      "videoTitle": _vm.title,
      "videoDuration": _vm.videoDuration,
      "controllType": 2,
      "title": _vm.title,
      "src": _vm.videoUrl,
      "pageUrl": _vm.imageSource,
      "themeType": _vm.themeType
    }
  }), (_vm.title) ? _c('text', {
    class: _vm.themeClass('title')
  }, [_vm._v(_vm._s(_vm.title))]) : _vm._e(), (_vm.content) ? _c('text', {
    class: _vm.themeClass('content')
  }, [_vm._v(_vm._s(_vm.content))]) : _vm._e(), (_vm.time) ? _c('text', {
    class: _vm.themeClass('time')
  }, [_vm._v(_vm._s(_vm.time))]) : _vm._e()], 1)])
},staticRenderFns: []}
module.exports.render._withStripped = true

/***/ }),
/* 67 */
/***/ (function(module, exports) {

module.exports={render:function (){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;
  return _c('div', {
    staticClass: ["cell-item"]
  }, [_c('text', {
    class: _vm.themeClass('text')
  }, [_vm._v(_vm._s(_vm.element.text.text))])])
},staticRenderFns: []}
module.exports.render._withStripped = true

/***/ }),
/* 68 */
/***/ (function(module, exports) {

module.exports={render:function (){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;
  return _c('qk-list', {
    attrs: {
      "loadmoreoffset": "50",
      "contentinset": {
        bottom: 50
      }
    },
    on: {
      "loadmore": _vm.loadMoreArticles
    }
  }, [_c('refresh', {
    staticClass: ["refresh"],
    attrs: {
      "display": _vm.refreshing ? 'show' : 'hide'
    },
    on: {
      "refresh": _vm.onPullToRefresh
    }
  }, [_c('loading-indicator', {
    staticClass: ["loading_icon"],
    attrs: {
      "color": "#000000"
    }
  })], 1), _vm._l((_vm.getArticles), function(article, index) {
    return _c('cell', {
      key: article.articleId,
      staticClass: ["cell-item"],
      appendAsTree: true,
      attrs: {
        "append": "tree"
      },
      on: {
        "click": function($event) {
          _vm.clickArticle(article.articleId)
        }
      }
    }, [_c('card', {
      attrs: {
        "initialElement": article,
        "cellIndex": index,
        "themeType": _vm.themeType
      }
    })], 1)
  })], 2)
},staticRenderFns: []}
module.exports.render._withStripped = true

/***/ }),
/* 69 */
/***/ (function(module, exports) {

module.exports={render:function (){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;
  return _c('div', {
    class: _vm.themeClass('wrapper'),
    style: {
      marginTop: this.ucConfig().env.statusBarHeight
    }
  }, [_c('div', {
    staticClass: ["topbar"]
  }, [_c('div', {
    staticClass: ["titlecontainer"]
  }, [_c('image', {
    staticClass: ["topicon"],
    attrs: {
      "src": this.isNightTheme() ? "localResImageNihgt://" + this.$getConfig().iconName : "localResImage://" + this.$getConfig().iconName
    }
  }), _c('text', {
    class: _vm.themeClass('title')
  }, [_vm._v(_vm._s(_vm.title))])])]), _c('div', [(_vm.showTabLayout) ? _c('tablayout', {
    staticClass: ["tablayout"],
    attrs: {
      "categoryUrl": this.$getConfig().url,
      "setData": _vm.subCategoriesOnlyName,
      "select": _vm.tabSelectIndex,
      "themeType": _vm.themeType,
      "iconMainColor": this.isNightTheme() ? this.mixTwoColors(this.$getConfig().iconColor, 0xFF000000, 0.5) : this.$getConfig().iconColor
    },
    on: {
      "tabselected": _vm.onTabSelect
    }
  }) : _c('div', {
    staticClass: ["placeholder"]
  })], 1), _c('uc-viewpager', {
    ref: "viewpager",
    staticClass: ["viewpager"],
    attrs: {
      "initialPage": "0",
      "currentItem": _vm.getCurrentIndex,
      "scrolleEnabled": "true"
    },
    on: {
      "pageScroll": _vm.onPageScroll,
      "pageSelected": _vm.onPageSelected
    }
  }, _vm._l((_vm.getSubCategories), function(category, index) {
    return _c('uc-pager-item', {
      key: index,
      staticClass: ["page"],
      appendAsTree: true,
      attrs: {
        "append": "tree"
      }
    }, [_c('article-list', {
      attrs: {
        "initialCategory": category,
        "initialIndex": index,
        "initialEventBus": _vm.eventBus,
        "initialHost": _vm.title,
        "themeType": _vm.themeType
      }
    })], 1)
  }))], 1)
},staticRenderFns: []}
module.exports.render._withStripped = true

/***/ }),
/* 70 */
/***/ (function(module, exports) {

module.exports={render:function (){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;
  return _c('div', {
    staticClass: ["cell-item"]
  }, [_c('quark-video', {
    staticClass: ["video"],
    style: {
      width: _vm.imgWidth + 'px',
      height: _vm.imgHeight + 'px'
    },
    attrs: {
      "posterUrl": _vm.imageSource,
      "videoUrl": _vm.videoUrl,
      "videoTitle": _vm.title,
      "controllType": 2,
      "title": _vm.title,
      "src": _vm.videoUrl,
      "pageUrl": _vm.imageSource,
      "themeType": _vm.themeType
    },
    on: {
      "load": function($event) {
        _vm.onloadVideo($event)
      }
    }
  })], 1)
},staticRenderFns: []}
module.exports.render._withStripped = true

/***/ }),
/* 71 */
/***/ (function(module, exports) {

module.exports={render:function (){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;
  return _c('div', {
    staticClass: ["cell-item-container"],
    style: {
      marginTop: (0 == _vm.cellIndex) ? 10 : 16
    }
  }, [_c('div', {
    staticClass: ["cell-item"]
  }, [(_vm.imageSource) ? _c('quark-image', {
    staticClass: ["image"],
    style: {
      width: _vm.imgWidth + 'px',
      height: _vm.imgHeight + 'px'
    },
    attrs: {
      "src": _vm.imgSrcExtend(_vm.imageSource, false),
      "resize": "contain",
      "placeholder": "localResImage://Common/image_placeholder_big.png"
    },
    on: {
      "load": _vm.onloadImg
    }
  }) : _vm._e(), (_vm.imageSource) ? _c('div', {
    class: _vm.themeClass('mask'),
    style: {
      width: _vm.imgWidth + 'px',
      height: _vm.imgHeight + 'px'
    }
  }) : _vm._e(), (_vm.title) ? _c('text', {
    class: _vm.themeClass('title')
  }, [_vm._v(_vm._s(_vm.title))]) : _vm._e(), (_vm.content) ? _c('text', {
    class: _vm.themeClass('content')
  }, [_vm._v(_vm._s(_vm.content))]) : _vm._e(), (_vm.time) ? _c('text', {
    class: _vm.themeClass('time')
  }, [_vm._v(_vm._s(_vm.time))]) : _vm._e()], 1)])
},staticRenderFns: []}
module.exports.render._withStripped = true

/***/ }),
/* 72 */
/***/ (function(module, exports) {

module.exports={render:function (){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;
  return _c('div', {
    class: _vm.themeClass('wrapper'),
    style: {
      marginTop: this.ucConfig().env.statusBarHeight
    }
  }, [(_vm.loading) ? _c('div', {
    staticClass: ["tip"]
  }, [_c('text', {
    class: _vm.themeClass('tip-text')
  }, [_vm._v("努力加载中...")])]) : (_vm.isError) ? _c('div', {
    staticClass: ["tip"],
    on: {
      "click": _vm.onClickErrorText
    }
  }, [_c('text', {
    class: _vm.themeClass('tip-text')
  }, [_vm._v("网络出错，点击重新加载")])]) : _c('qk-list', {
    staticClass: ["element-list"],
    style: {
      width: _vm.screenWidth,
      height: _vm.listHeight
    },
    attrs: {
      "contentinset": {
        bottom: this.ucConfig().env.toolbarHeight
      }
    }
  }, _vm._l((_vm.getDisplayElements), function(element) {
    return _c('cell', {
      key: element.id,
      style: {
        width: _vm.screenWidth + 'px'
      },
      appendAsTree: true,
      attrs: {
        "append": "tree"
      }
    }, [_c('articleElement', {
      attrs: {
        "initialElement": element,
        "themeType": _vm.themeType
      }
    })], 1)
  }))], 1)
},staticRenderFns: []}
module.exports.render._withStripped = true

/***/ }),
/* 73 */
/***/ (function(module, exports) {

module.exports={render:function (){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;
  return _c('div', {
    staticClass: ["cell-item-container"],
    style: {
      marginTop: (0 == _vm.cellIndex) ? 10 : 16
    }
  }, [_c('div', {
    staticClass: ["cell-item"]
  }, [_c('div', {
    staticClass: ["item-left"]
  }, [(_vm.title) ? _c('text', {
    class: _vm.themeClass('title')
  }, [_vm._v(_vm._s(_vm.title))]) : _vm._e(), (_vm.content) ? _c('text', {
    class: _vm.themeClass('content')
  }, [_vm._v(_vm._s(_vm.content))]) : _vm._e(), (_vm.time) ? _c('text', {
    class: _vm.themeClass('time')
  }, [_vm._v(_vm._s(_vm.time))]) : _vm._e()]), _c('div', [(_vm.imageSource) ? _c('image', {
    staticClass: ["logo"],
    attrs: {
      "src": _vm.imgSrcExtend(_vm.imageSource, true),
      "placeholder": "localResImage://Common/image_placeholder.png",
      "resize": "cover"
    },
    on: {
      "load": _vm.onloadImg
    }
  }) : _vm._e(), _c('div', {
    class: _vm.themeClass('mask')
  })])]), _c('dividingline', {
    class: _vm.themeClass('divider')
  })], 1)
},staticRenderFns: []}
module.exports.render._withStripped = true

/***/ }),
/* 74 */
/***/ (function(module, exports) {

module.exports={render:function (){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;
  return _c('div', {
    staticClass: ["cell-item"]
  }, [_c('text', {
    class: _vm.themeClass('title')
  }, [_vm._v(_vm._s(_vm.element.text.title))]), _c('div', {
    staticClass: ["title-divider"],
    style: {
      backgroundColor: this.isNightTheme() ? '#555555' : this.$getConfig().iconColor
    }
  }), _c('div', {
    staticClass: ["author-container"]
  }, [_c('text', {
    class: _vm.themeClass('author')
  }, [_vm._v(_vm._s(_vm.element.text.author) + "  " + _vm._s(_vm.time))])])])
},staticRenderFns: []}
module.exports.render._withStripped = true

/***/ }),
/* 75 */
/***/ (function(module, exports) {

module.exports={render:function (){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;
  return _c('div', {
    staticClass: ["cell-item"]
  }, [_c('quark-image', {
    staticClass: ["logo"],
    style: {
      width: _vm.imgWidth + 'px',
      height: _vm.imgHeight + 'px'
    },
    attrs: {
      "src": _vm.imgSrcExtend(_vm.imageSource, false),
      "resize": "contain",
      "placeholder": "localResImage://Common/image_placeholder_big.png"
    },
    on: {
      "load": function($event) {
        _vm.onloadImg($event)
      }
    }
  }), _c('div', {
    class: _vm.themeClass('mask'),
    style: {
      width: _vm.imgWidth + 'px',
      height: _vm.imgHeight + 'px'
    }
  })], 1)
},staticRenderFns: []}
module.exports.render._withStripped = true

/***/ }),
/* 76 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _App = __webpack_require__(10);

var _App2 = _interopRequireDefault(_App);

var _router = __webpack_require__(7);

var _router2 = _interopRequireDefault(_router);

var _mixins = __webpack_require__(9);

var _mixins2 = _interopRequireDefault(_mixins);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// register global mixins.
Vue.mixin(_mixins2.default

// create the app instance.
// here we inject the router and store to all child components,
// making them available everywhere as `this.$router` and `this.$store`.
); // import Vue from 'vue'
new Vue(Vue.util.extend({ el: '#root', router: _router2.default }, _App2.default));

/***/ })
/******/ ]);