if (this && this.addEventListener) {
	this.addEventListener('message', function(e) {
		if (e.data.indexOf('importScripts') >= 0) {
			eval(e.data)
		} else {
			postMessage(eval(e.data));
		}
	}, false);
}

var document = {};
var console = {};
var ucapi = {};
var dom = {};

//保存JS层对dom树的修改
var actionQueen = new Array();
function excuteActionToNative() {
	var actionQueenString = JSON.stringify(actionQueen);
	actionQueen = new Array();

	return actionQueenString;
}

//管理JS回调
var callbackIndex = 0;
var callbackMap = new Map();
function triggerCallback(id, keepAlive, params) {
	var callback = callbackMap.get(id);
	if (callback != undefined) {
		callback(JSON.parse(params));
	}
	if (!keepAlive) {
		callbackMap.delete(id);
	}
}

function addCallback(callback) {
	var index = callbackIndex;
	callbackMap.set(index, callback);
	callbackIndex = callbackIndex+1;
	return index;
}

function getElementById(node, id) {
	var result = undefined;
	if (node["id"] == id) {
		result = node;
	}

	for (var i = 0; i < node["childrens"].length; i++) {
		var ret = getElementById(node["childrens"][i], id);
		if (ret != undefined) {
			result = ret;
			break;
		}
	}

	return result;
}

function attrWatch(node, key) {
	var storeKey = key;
	if (storeKey === 'className') {
		storeKey = 'class';
	}
	else if (storeKey === 'innerText') {
		storeKey = 'text';
	}
	node["_"+storeKey] = node[storeKey];
	Object.defineProperty(node, key, {
		set: function(newValue) {
			node["_"+storeKey] = newValue;
			var action = {
				'op': 'up_attr',
				'ref': node.ref,
				'key': storeKey,
				'value': newValue
			};
			actionQueen.push(action);
		},
		get: function() {
			if (storeKey === 'style') {
				return node;
			}
			return node["_"+storeKey];
		}
	});
}

function styleWatch(node, key) {
	Object.defineProperty(node, key, {
		set: function(newValue) {
			var cssKey = "";
			for(i = 0; i < key.length; i++){
				var c = key.charAt(i);
				if (c >= 'A' && c <= 'Z') {
					cssKey = cssKey + '-' + c.toLowerCase();
				}
				else {
					cssKey = cssKey + c;
				}
			}
			var action = {
				'op': 'up_css',
				'ref': node.ref,
				'key': cssKey,
				'value': newValue+""
			};
			actionQueen.push(action);
		},
		get: function() {
			return node;
		}
	});
}

function nodeBinding(node) {

    if (node.binding === undefined) {//每个节点只需要绑定一次
    	node.binding = true;

    	attrWatch(node, "className");
    	attrWatch(node, "innerText");
    	attrWatch(node, "style");
    	attrWatch(node, "showScrollbar");

    	styleWatch(node, "display");
    	styleWatch(node, "width");

    	styleWatch(node, "top");
    	styleWatch(node, "left");
    	styleWatch(node, "bottom");
    	styleWatch(node, "right");

    	styleWatch(node, "height");
    	styleWatch(node, "minHeight");
    	styleWatch(node, "maxHeight");
    	styleWatch(node, "minWidth");
    	styleWatch(node, "maxWidth");
    	styleWatch(node, "position");
    	styleWatch(node, "margin");
    	styleWatch(node, "marginLeft");
    	styleWatch(node, "marginRight");
    	styleWatch(node, "marginTop");
    	styleWatch(node, "marginBottom");
    	styleWatch(node, "alignItems");
    	styleWatch(node, "alignSelf");
    	styleWatch(node, "justifyContent");
    	styleWatch(node, "flexDirection");
    	styleWatch(node, "flexWrap");
    	styleWatch(node, "flex");
    	styleWatch(node, "padding");
    	styleWatch(node, "paddingLeft");
    	styleWatch(node, "paddingRight");
    	styleWatch(node, "paddingTop");
    	styleWatch(node, "paddingBottom");
    	styleWatch(node, "backgroundColor");
    	styleWatch(node, "borderRadius");
    	styleWatch(node, "border");
    	styleWatch(node, "opacity");
    	styleWatch(node, "fontSize");
    	styleWatch(node, "textDecoration");
    	styleWatch(node, "color");
    	styleWatch(node, "textOverflow");
    	styleWatch(node, "lines");
    	styleWatch(node, "textAlign");
    	styleWatch(node, "fontFamily");
    	styleWatch(node, "fontWeight");
    	styleWatch(node, "lineHeight");
    	styleWatch(node, "lineSpacingRatio");
    	styleWatch(node, "transitionDuration");
    	styleWatch(node, "transitionDelay");

    	node.invoke = function(api, params, callback) {
    		var id = addCallback(callback);
    		params.callback_native = id + '';
    		var action = {
    			'op': 'call_func',
    			'ref': node.ref,
    			'api': api,
    			'params': params
    		};
    		actionQueen.push(action);
    	};
    }
    
    return node;
}

function querySelectorsByClass(node, cl, array) {
	if (node != undefined) {
		if (node.className != undefined) {
			var cls = node.className.split(" ");
			for (var i = 0; i < cls.length; i++) {
				if (cls[i] == cl) {
					nodeBinding(node);
					array.push(node);
				}
			}
		}

		for (var i = 0; i < node["childrens"].length; i++) {
			querySelectorsByClass(node["childrens"][i], cl, array);
		}
	}
}


document.getElementById = function(id) {
	var obj = getElementById(dom, id);
	return nodeBinding(obj);
}

document.querySelectorAll = function(selectors) {
	var els = new Array();
	if (selectors[0] == '.') {
		querySelectorsByClass(dom, selectors.substring(1), els);
	}
	return els;
}

document.submit = function(params) {
	var action = {
		'op': 'submit',
		'params': params
	};
	actionQueen.push(action);
}

function setTimeout(callback, millisec) {
	var id = addCallback(callback);
	var action = {
		'op': 'create_timer',
		'millisec': millisec,
		'repeat': false,
		'callback': id + ''
	};
	actionQueen.push(action);
}

function setinterval(callback, millisec) {
	var id = addCallback(callback);
	var action = {
		'op': 'create_timer',
		'millisec': millisec,
		'repeat': true,
		'callback': id + ''
	};
	actionQueen.push(action);
}

ucapi.invoke = function(api, params, callback) {
	var id = addCallback(callback);
	var action = {
		'op': 'ucapi',
		'api': api,
		'params': params,
		'callback': id + ''
	};
	actionQueen.push(action);
};

console.log = function(log) {
	var action = {
		'op': 'log',
		'log': log
	};
	actionQueen.push(action);
}
